\NeedsTeXFormat{LaTeX2e}%
\ProvidesClass{relatorioLabExp}[2021/06/17, v3.2 de Rui Jorge Agostinho]%

\newcommand{\@versaoNum}{RA v3.2}%
\newcommand{\@versao}{\@versaoNum\ de relatorioFisExpDev}%

\newcommand{\@myClassName}{relatorioLabExp}%
\newcommand{\@useMyClassName}[1]{\renewcommand{\@myClassName}{#1}}%

\newcommand{\ttENspc}[1]{\texttt{\StrSubstitute{#1}{ }{\enskip }}}%

\newcommand{\@fontTypeMacroName}{}%

\newcommand{\@macroName}[4][B]{%
\IfStrEq{#1}{}{\texttt{#2#3}}%
{%
 \IfBeginWith{#1}{B}%
  {\textbackslash\texttt{#2#3}%
   \StrGobbleLeft{#1}{1}[\@fontTypeMacroName]%
  }%
  {\renewcommand{\@fontTypeMacroName}{#1}}%
}%
\IfStrEq{#4}{}%
 {\par\vspace*{-2mm}}%
 {\IfBeginWith{#4}{.}{}%
  {\IfStrEq{\@fontTypeMacroName}{}{#4}%
   {\IfStrEqCase{\@fontTypeMacroName}{%
    {tt}{\texttt{#4}}%
    {ttss}{\ttENspc{#4}}%
    {it}{\textit{#4}}%
    {sl}{\textsl{#4}}%
    {sm}{{\small #4}}%
    {bf}{\textbf{#4}}%
   }}%
  }%
 }%
}%

\newcommand{\macroNameCodigo}[4][B]{\@macroName[#1]{#2}{#3}{#4}}%

\newcommand{\@helpTxtPackages}{\par\vspace*{2mm}\noindent%
\uline{\textsc{Packages Inclu\ii das e Necess\'arias \`a Classe}}  '\texttt{\@myClassName}'\par\vspace*{3mm} %
\noindent Estas packages s\ao\ usadas nas muitas defini\coes\ internas da classe. Para a %
explica\cao\ detalhada de cada uma consulte o reposit\'orio oficial em %
\https[\small]{www.ctan.org}.\par\vspace*{2mm}%
}%

\newcommand{\@appendToHelpPackages}[2]{%
\csgappto{@helpTxtPackages}{%
\noindent-- \texttt{\textbf{#1:}}\ #2\par\vspace*{1.5mm}}%
}%

\newcommand{\@helpTxtPackagesXtras}{\vspace*{2mm}\noindent%
\uline{\textsc{Outras Packages Inclu\ii das mas N\~{a}o Essenciais \`a Classe}} %
'\texttt{\@myClassName}'\par\vspace*{3mm}%
\noindent S\ao\ tamb\'em  inclu\ii das outras packages que n\ao\ s\ao\ usadas internamente na classe, mas apenas porque s\ao\ \'uteis nos textos cient\ii ficos e permite aos utilizadores beneficiarem logo delas. %
Para a explica\cao\ detalhada de cada uma consulte o reposit\'orio oficial em  \https[\small]{www.ctan.org}.\par\vspace*{2mm}\par}%

\newcommand{\@appendToHelpPackagesXtras}[2]{%
\csgappto{@helpTxtPackagesXtras}{%
\noindent-- \texttt{\textbf{#1:}}\ #2\par\vspace*{1.5mm}}%
}%

\newcommand{\HelpOutrosComandosPreambulo}{}%

\newcommand{\@appendHelpOutrsCmdsPreamb}[3]{%
\csgappto{HelpOutrosComandosPreambulo}{%
\item\texttt{\textbackslash{#1}\ttENspc{#2}}\ #3}%
}%

\newcommand{\@helpTxtAbreviaturas}{%
\vspace*{2mm}\noindent%
\uline{\textsc{Abreviaturas de Designa\cc\~{o}es Comuns Dispon\ii veis na classe}} %
'\texttt{\@myClassName}'\par\vspace*{3mm}%
\noindent H\'a muitas designa\coes\ que s\ao\ vulgarmente usadas mas que por serem%
menos pr\'aticas de escrever em \LaTeX, criaram-se abreviaturas das mesmas. S\ao\ %
comandos que substituem essas palavras ou designa\coes. %
As que \textsl{n\ao} terminam com um ponto (.) acrescentam ou n\ao\ um espa\co\ em branco (\textvisiblespace) de seguida, dependendo do caracter que se segue. %

\noindent\textbf{HELP}: pode ver esta lista de todas as abreviaturas se usar \texttt{$\backslash$helpAbreviaturas} em qualquer parte do texto. %
Isso permite tirar d\'uvidas sobre a sua utiliza\cao\ sem sair do documento.\\ %
}%

\newcommand{\@appendToHelpAbreviaturas}[2][]{%
\csgappto{@helpTxtAbreviaturas}{\\ %
\texttt{\textbf{#1\textbackslash{#2}}=}\ #1\@nameuse{#2}}%
}%

\newcommand{\@helpTxtEnvironments}{\par\vspace*{3mm}\noindent%
\uline{\textsc{Environments dispon\ii veis na classe}} '\texttt{\@myClassName}'\par\vspace*{4mm}%
}%

\newcommand{\@nomeItem}{}%
\newcommand{\@opcoesItem}{}%
\newcommand{\@textoItem}{}%

\newcommand{\@fmtHelpEnvironment}[6][]{%
--\textit{\textbf{#2:}} environment \texttt{#3} #6 %
Usar o ambiente%
\IfStrEq{#1}{}{}{que fica com a etiqueta \texttt{#1} (opcional) para refer\^encia.}\\ %
\ifthenelse{\(\NOT\isempty{#1}\) \AND \(\NOT\isempty{#4}\)}%
 {\@macroName[Btt]{begin}{\{#3\}}{[#1]#4}}%
 {\IfStrEq{#4}{}%
  {\IfStrEq{#1}{}%
   {\@macroName{begin}{\{#3\}}{.}}%
   {\@macroName[Btt]{begin}{\{#3\}}{[#1]}}%
  }%
  {\@macroName{[Btt]begin}{\{#3\}}{#4}}%
}%
\IfBeginWith{#5}{item}%
 {\StrPosition[1]{#5}{ }[\@posicaoUmSpaceB]%
  \StrPosition[2]{#5}{ }[\@posicaoDoisSpaceB]%
  \StrLen{#5}[\@lengthItemString]%
  \ifthenelse{\equal{\@posicaoUmSpaceB}{0}}%
   {\renewcommand{\@nomeItem}{#5}%
    \renewcommand{\@opcoesItem}{}%
    \renewcommand{\@textoItem}{.}%
   }%
   {%
    \StrBefore{#5}{ }[\@nomeItem]%
    \ifthenelse{\equal{\@posicaoDoisSpaceB}{0}}%
     {\StrMid{#5}{\number\numexpr\@posicaoUmSpaceB+1}{\@lengthItemString}[\@opcoesItem]%
      \renewcommand{\@textoItem}{.}%
     }%
     {%
      \StrMid{#5}{\number\numexpr\@posicaoUmSpaceB+1}{\number\numexpr\@posicaoDoisSpaceB-1}[\@opcoesItem]%
      \StrMid{#5}{\number\numexpr\@posicaoDoisSpaceB+1}{\@lengthItemString}[\@textoItem]%
     }%
   }%
  \@macroName[Bsm]{\@nomeItem}{\@opcoesItem}{\@textoItem}%
 }%
{#5}%
\@macroName{end}{\{#3\}}{.}%
}%

\@namedef{HELPmeu}{ola}%
\renewcommand{\HELPmeu}[1]{#1} %

\newcommand{\@makeHELPdoComando}[2]{%
\@namedef{HELP#1}{#2}%
}%

\newcommand{\@appendToHelpEnvironments}[6][]{%
\def\@shortHELP{shortHELP#3}%
\@namedef{\@shortHELP}{%
\@fmtHelpEnvironment[#1]{#2}{#3}{#4}{#5}{#6}%
}%
\csgappto{@helpTxtEnvironments}{\par%
\@fmtHelpEnvironment[#1]{#2}{#3}{#4}{#5}{#6}\par%
Use \@macroName{HELP#3}{}{.} para ver esta descri\cao.\par\vspace*{1.7mm}%
}%
\@makeHELPdoComando{#3}{%
---\quad \texttt{HELP do environment} \@macroName{#3}{}{.}\quad---\par%
\@fmtHelpEnvironment[#1]{#2}{#3}{#4}{#5}{#6}\par%
---\quad\texttt{fim do HELP do environment}\quad---%
}%
}%

\newcommand{\@explicaEnvironment}[4][item]{%
\ \\ %
 \ifthenelse{\isempty{#2}}%
  {\@macroName{begin}{\{#3\}}{.}}%
  {\@macroName{begin}{\{#3\}[#2]}{.}}%
 \IfSubStr{#1}{item}%
  {\@macroName[Bttss]{#1}{}{ #4}}%
  { #4}%
 \ \@macroName{end}{\{#3\}}{.}%
}%

\newcommand{\explainEnviron}[4][item]{%
\ \\ %
 \ifthenelse{\isempty{#2}}%
  {\@macroName{begin}{\{#3\}}{.}}%
  {\@macroName{begin}{\{#3\}#2}{.}}%
 \\ \IfSubStr{#1}{item}%
  {\@macroName[Bttss]{#1}{}{ #4}}%
  { #4}%
 \\ \@macroName{end}{\{#3\}}{.}%
}%

\newcommand{\@helpTxtOpcoes}{}%

\newcommand{\@appendToHelpOpcoes}[4][11pt,]{%
\csgappto{@helpTxtOpcoes}{%
\item[#2 --] #3. #4.\\ %
Use: \@macroName[Btt]{documentclass}{[#1#2]}{\{\@myClassName\}}}%
}%

\providecommand{\@fmtComando}[3][]{%
\ifthenelse{\equal{#3}{}}{\indent}%
{\noindent-- \textit{\textbf{#3:}} usar comando }%
  \@macroName{#1}{#2}{.}%
}%

\newcommand{\@appendToHelpCmd}[5][]{%
\def\@shortHELP{shortHELP#1}%
\@namedef{\@shortHELP}{%
\@fmtComando[#1]{#2}{#3}%
 #4%
}%
\def\@helpCmdNm{@helpTxtComandos#5}%
\csgappto{\@helpCmdNm}{\par%
\@fmtComando[#1]{#2}{#3}%
 #4 %
Use \@macroName{HELP#1}{}{.} para ver esta descri\cao.\par\vspace*{1.6mm}%
}%
\@makeHELPdoComando{#1}{\par%
---\quad \texttt{HELP do comando} \@macroName{#1}{}{.}\quad---\par %
\@fmtComando[#1]{#2}{#3}%
 #4%
\par%
---\quad\texttt{fim do HELP do comando}\quad---}%
}%

\newcommand{\@formataTitHelpTxtCmds}[2]['\texttt{\@myClassName}']{\par\vspace*{3mm}\noindent%
\underline{\textsc{#2}}\ #1\par\vspace*{4mm}}%

\newcommand{\@helpTxtComandosOpcionais}{%
\@formataTitHelpTxtCmds{Comandos Opcionais dispon\ii veis na classe}}%

\newcommand{\@helpTxtComandosReferir}{%
\@formataTitHelpTxtCmds[]{Comandos Opcionais de Refer\^encias Inteligentes a 'labels'}}%

\newcommand{\@helpTxtComandosFigsTabs}{%
\@formataTitHelpTxtCmds[]{Comandos Opcionais para Figuras e Tabelas com Texto ao lado}}%

\newcommand{\@helpTxtComandosMatematicos}{%
\@formataTitHelpTxtCmds[]{Comandos Opcionais Matem\'aticos}}%

\newcommand{\@helpTxtComandosPeambulo}{%
\@formataTitHelpTxtCmds{Defini\coes\ Obrigat\'orias no Pre\^ambulo dos Documentos, em}}%

\newcommand{\@appendToHelpPeambulo}[4][]{%
\csgappto{@helpTxtComandosPeambulo}{\par%
\@fmtComando[#1]{#2}{#3}%
 #4\par}%
}%

\RequirePackage{etoolbox}%

\RequirePackage[intlimits]{amsmath}%
\@appendToHelpPackages{amsmath}{Da American Mathematical Society. Provides miscellaneous enhancements for improving the information structure and printed output of documents containing mathematical formulas. Altera e fornece alguns comandos \'uteis como o  \@macroName{dfrac}{\{numrdr\}\{denom\}}{.} que faz a frac\cao\ com letras menores, ou %
\@macroName{boxed}{\{f\'ormula\}}{.} puts a box around its argument, like \textbackslash\texttt{fbox} except that the contents are in math mode, etc. Pode ver tudo em %
\http[\small]{mirrors.up.pt/pub/CTAN/macros/latex/required/amsmath/amsldoc.pdf}%
}%

\RequirePackage[english,portuges]{babel,varioref}%
\@appendToHelpPackages{babel}{Uso da l\ii ngua portuguesa nos comandos que reportam em texto, como a designa\cao\ das sec\coes\ (Cap\ii tulo, Sec\cao\, Bibliografia, etc.), nomes dos estilos (Relat\'orio, Tese, etc.), al\'em de fazer a hifena\cao\ e acentua\cao\ das palavras.}%

\RequirePackage[T1]{fontenc}%
\@appendToHelpPackages{fontenc}{\'E usada a codifica\cao\ de fontes T1.%
Se usar num outro \textit{doc.tex}, seu, deve coloc\'a-la \uline{\textit{antes}} do\\ %
\@macroName[Btt]{usepackage}{[xx]}{\{inputenc\}} onde \texttt{xx=latin1} ou \texttt{utf8}.}%
 
\RequirePackage{graphicx}%
\@appendToHelpPackages{graphicx}{A package principal para incluir figuras num documento. Dentro do \LaTeX\ pode rodar, expandir, cortar, etc., uma figura, ou seja, n\ao\ precisa de edit\'a-la externamente. Tamb\'em define as funcionalidades para colorir o texto.%
O uso t\ii pico \'e \@macroName{includegraphics}{[opcoes]\{file.xxx\}}{.}}%

\RequirePackage{float}%
\@appendToHelpPackages{float}{Introduz a op\cao\ [H] num float, que o coloca no s\ii tio onde exatamente est\'a definido. Use com cuidado pois pode dar mal: o float pode ficar cortado a meio, no final da p\'agina.}%

\RequirePackage{footnotehyper}%
\@appendToHelpPackages{footnotehyper}{Cria o ambiente \texttt{footnote} sem precisar da package desse nome, com todas as suas funcionalidades, al\'em de fazer hiper-refer\^encias em notas de rodap\'e e usar cor. \'E compat\ii vel com a package \texttt{hyperref} mas aut\'onoma.}%

\RequirePackage[sc,osf]{mathpazo}%
\@appendToHelpPackages{mathpazo}{'math font' para a fonte Palatino usada no texto.}%

\RequirePackage{pageslts}%
\pagenumbering{arabic} %

\@appendToHelpPackages{pageslts}{Boa para calcular corretamente o n\'umero da \'ultima p\'agina no doc, na vari\'avel \textit{lastpage}.}%

\RequirePackage{palatino} %

\RequirePackage{setspace} %
\@appendToHelpPackages{setspace}{Provides support for setting the spacing between lines in a document. Package options include singlespacing, onehalfspacing, and doublespacing. Alternatively the spacing can be changed as required with the \@macroName{singlespacing}{}{.}, \@macroName{onehalfspacing}{}{.}, and \@macroName{doublespacing}{}{.} commands. Other size spacings also available.}%

\usepackage[overload]{textcase}%
\@appendToHelpPackages{textcase}{Redefine os commandos  \@macroName{MakeUppercase}{\{text\}}{.} e \@macroName{MakeLowercase}{\{text\}}{.} do \LaTeX, e que n\ao\ alteram os caracteres no modo matem\'atico que hajam nos seus argumentos.}%

\@appendToHelpPackages{varioref}{Faz refer\^encias do tipo 'previous page', 'next page', etc.. Com a package \texttt{babel} estas ficam em Portugu\^es. Alguns comandos poss\ii veis s\ao: \@macroName{vref}{\{lbl\}}{.}, \@macroName{vrefrange}{\{lbl\}}{.}, \@macroName{vpageref}{\{lbl\}}{.}.}%

\RequirePackage{xifthen}%
\@appendToHelpPackages{xifthen}{Exten\soes\ \`a package \texttt{ifthen}. Essencial para as defini\coes\ na classe \texttt{\@myClassName}.}%

\RequirePackage{xspace}%
\@appendToHelpPackages{xspace}{D\'a o comando \texttt{\textbackslash xspace}. It adds a space unless the macro is followed by certain punctuation characters. Should be used at the end of a macro designed to be used mainly in text.}%

\RequirePackage{xstring}%
\@appendToHelpPackages{xstring}{Introduz exten\soes\ \`a manipula\cao\ de strings puras (sem comandos no meio).} %

\RequirePackage[verbose]{wrapfig} %
\newlength{\OLDtextwidth}%
\newlength{\OLDcolumnsep}%
\setlength{\OLDcolumnsep}{\columnsep}%
\@appendToHelpPackages{wrapfig}{Coloca texto \`a esquerda com uma figura \`a direita do texto, dentro da largura do texto na p\'agina. Cria o ambiente \texttt{wrapfigure} no qual se coloca uma figura que fica rodeada pelo texto: por cima, ao lado e por baixo (com \@macroName[Btt]{includegraphics}{[opcoes]}{\{fig\})}.}%

\RequirePackage{zref-user,zref-abspage,zref-lastpage}%
\@appendToHelpPackages{zref}{Usam-se as 3 variantes \texttt{zref-user}, \texttt{zref-abspage}, \texttt{zref-lastpage}, para calcular bem a numera\cao\ da \'ultima p\'agina, e colocar refer\^encias a esta file no rodap\'e da \'ultima p\'agina no documento.}%

\@ifpackagelater{zref-abspage}{2013/02/09}{%
  \newcommand*{\iffancylastpage}{%
    \ifnum\zref@extract{LastPage}{abspage}=\numexpr\value{abspage}+1 %
      \expandafter\@secondoftwo%
    \else%
      \expandafter\@secondoftwo%
    \fi%
  }%
}{%
  \newcommand*{\iffancylastpage}{%
    \ifnum\zref@extractdefault{LastPage}{abspage}{-1}%
        =\numexpr\value{abspage}+1\relax%
      \expandafter\@firstoftwo%
    \else%
      \expandafter\@secondoftwo%
    \fi%
  }%
}%

\RequirePackage{amssymb}%
\@appendToHelpPackagesXtras{amssymb}{Da American Mathematical Society: fornece uma boa cole\cao\  de s\ii mbolos matem\'aticos. Inclui os s\ii mbolos dos n\'umeros Reais \@macroName{mathbb}{\{R\}}{.}$=\mathbb{R}$, Naturais \@macroName{mathbb}{\{N\}}{.}$=\mathbb{N}$, \@macroName{hslash}{}{.}$= \hslash$, \@macroName{propto}{}{.}$=\,\propto$, \@macroName{rightleftarrows}{}{.}$=\,\rightleftarrows$, \@macroName{leqslant}{}{.}$=\, \leqslant$, \@macroName{geqslant}{}{.}$=\,\geqslant$, etc. Pode ver uma lista completa de s\ii mbolos em \\ %
\http[\small]{milde.users.sourceforge.net/LUCR/Math/mathpackages/amssymb-symbols.pdf}.}%

\RequirePackage{amsthm}%
\@appendToHelpPackagesXtras{amsthm}{Da American Mathematical Society. Helps to define theorem-like structures; The package defines a \texttt{proof} environment that automatically adds a QED symbol at the end. The enhanced \@macroName{newtheorem}{}{.} recognizes a \@macroName{theoremstyle}{}{.} specification. The package \texttt{amsthm} must be loaded after \texttt{amsmath}, not before.}%

\RequirePackage{booktabs}%
\renewcommand{\arraystretch}{1.1}%
\@appendToHelpPackagesXtras{booktabs}{To enable the easy production of tables such as should appear in published scientific books and journals. %
What distinguishes these from plain \LaTeX\ tables is the default use of additional space above and below rules, rules of varying 'thickness' and the absence of vertical rules and double rules. Para formatar tabelas mais lindas usa o \@macroName{arraystretch}{}{=1.1}}%

\RequirePackage[usenames,dvipsnames]{xcolor}%

\RequirePackage[oldvoltagedirection]{circuitikz}%
\@appendToHelpPackagesXtras{circuitikz}{Faz desenhos de circuitos el\'etricos, baseados no \texttt{tikz}. Usar c\'odido no \textit{environment}: %
\@explicaEnvironment[]{line width=0.9pt}{circuitikz}{\textit{com comandos de circuitikz ao estilo de}\\ \@macroName{draw}{$(x_1,y_1)$ to$[$bipole,l="R",etc$]$}%
{ $(x_2,y_2)$ -\!- $(x_3,y_3)$ ;}}%
, em que o \texttt{bipole} descreve um componente, como \texttt{R}, \texttt{C}, \texttt{L}, \texttt{inductor} ou \texttt{sinusoidal voltage source}, etc. %
A op\cao\ para usar unidades SI \texttt{siunitx}  n\ao\ funciona.}%

\RequirePackage{icomma}%
\@appendToHelpPackagesXtras{icomma}{No modo matem\'atico ao usar a v\ii rgula como separador decimal insere o espa\co\ correto entre ela e o d\ii gito seguinte. Sem ela, h\'a um espa\co\ extra tal como v\^e a seguir a esta v\ii rgula, fim!}%

\RequirePackage{multirow}%
\@appendToHelpPackagesXtras{multirow}{Permite agregar linhas e/ou colunas numa tabela.}%

\RequirePackage[normalem]{ulem}%
\@appendToHelpPackagesXtras{ulem}{Faz sublinhados do \textit{texto} com \textit{quebra inteligente  de linha e p\'agina}, com hifeniza\cao, em contraste com o regular \@macroName{underline}{\{\textit{texto}\}}{.}. Deve usar o comando: \@macroName{uline}{\{\textit{texto}\}}{.}.}%
\@appendToHelpPackagesXtras{xcolor}{Introduz exten\soes\ \`a package \texttt{\textbf{color}} para usar texto colorido. H\'a diversos comandos mas os mais usados s\ao:%
\@macroName{definecolor}{[\textit{nomeCor}]\{rgb\}\{r,g,b\}}{.} que define uma cor no modelo \texttt{rgb} e atribui-lhe o \texttt{\textit{nomeCor}}. Os valores \texttt{r}, \texttt{g} e \texttt{b} est\ao\ em percentagens: 0->1. Se usar o modelo de cor \texttt{RGB} ent\ao\ os valores \texttt{r}, \texttt{g} e \texttt{b} v\ao\ de 0 a 255. %
O comando %
\@macroName{textcolor}{[\textit{nomeCor}]\{\textit{texto}\}}{.} escreve o \texttt{\textit{texto}} na cor \texttt{\textit{nomeCor}}, e o comando \@macroName{color}{\{\textit{nomeCor}\}}{.} escreve todo o texto que aparecer a seguir na cor \texttt{\textit{nomeCor}}.%
}%

\newboolean{@ingles} %
\setboolean{@ingles}{false}%

\DeclareOption{ingles}{%
 \setboolean{@ingles}{true}%
}%
\ifthenelse{\not\boolean{@ingles}}%
{%
\renewcommand{\reftextbefore}{(na p\'ag.\ \reftextvario{anterior}{precedente})}%
\renewcommand{\reftextafter}{(na \reftextvario{p\'ag.\ seguinte}{pr\'oxima%
                             p\'ag.})}%
\renewcommand{\reftextcurrent}{{\reftextvario{nesta p\'agina}{nesta p\'ag.}}}%
}%
{%
\renewcommand{\reftextbefore}{(on the previous page)}%
\renewcommand{\reftextafter}{(on the next page)}%
\renewcommand{\reftextcurrent}{on this page}%
}%

\@appendToHelpOpcoes[]{11pt}{Tamanho da letra no documento}{Esta op\cao\ define o tamanho base da letra que \'e usada. Pode escolher \texttt{10pt} ou \texttt{12pt}, mas sugere-se que use os \texttt{11pt} porque d\'a  melhor arranjo de espa\co\ e tem boa leitura no tipo de fonte usada, a \emph{Palatino}. Aten\cao: se estiver a correr \LaTeX\ no \textit{Overleaf} ent\ao\ \uwave{deve mesmo usar} \texttt{10pt}}%

\newcommand{\@encoding}{latin1}%
\newboolean{@utf8}%
\setboolean{@utf8}{false}%

\DeclareOption{utf8}{%
  \setboolean{@utf8}{true}%
  \renewcommand{\@encoding}{utf8}%
}%
\@appendToHelpOpcoes{utf8}{Codifica\cao\ UTF8 das files}{ATEN\CAO: \'e \textit{obrigat\'orio} usar a op\cao\ \texttt{\textbf{utf8}} se for esta a codifica\cao\ dos caracteres na sua file de texto, por exemplo '\texttt{meuRelatorioLab3.tex}'. Este \'e o caso  %
se estiver a correr o \LaTeX\ no \textit{Overleaf}. No in\ii cio use..}%

\newboolean{@artigo}%
\setboolean{@artigo}{false}%

\DeclareOption{paper}{%
  \setboolean{@artigo}{true}%
}%
\@appendToHelpOpcoes{paper}{Capa de artigo cient\ii fico}%
{Esta op\cao\ altera a disposi\cao\ do texto na folha de rosto. Para al\'em do t\ii tulo do trabalho ficam os nomes dos autores do artigo (dispostos em linha), institui\cao\ (ou n\ao), disciplina (ou n\ao). Pode ainda eliminar os nomes do Departamento e da Disciplina, definindo-os com  a sequ\^encia \{\textbackslash\textvisiblespace\} nos comandos respetivos. %
Desaparece o formato em Turma, Grupo, Aula e Docente t\ii picas do formato de relat\'orio}%

\newboolean{@indice}%
\setboolean{@indice}{false}%

\DeclareOption{indice}{%
  \setboolean{@indice}{true}%
}%
\@appendToHelpOpcoes{indice}{Criar um \II ndice}{%
Inclui a lista do "\textbf{Conte\'udo}"\ logo no in\ii cio, antes do \textbf{Resumo} e num formato compacto: letra num tamanho inferior e espa\co\ entrelinhas mais curto.  \'E uma lista com a numera\cao\ e os nomes de todas as sec\coes, subsec\coes\ que o relat\'orio tem e em que p\'agina est\ao. O objetivo \'e ocupar pouco espa\co\ na p\'agina inicial %
pois o texto \'e um relat\'orio, n\ao\ \'e uma tese nem um livro}%

\newboolean{@indicePrg}%
\setboolean{@indicePrg}{false}%

\DeclareOption{indicePrg}{%
  \setboolean{@indicePrg}{true}%
}%
\@appendToHelpOpcoes{indicePrg}{Cria o \II ndice e Lista de Programas}{%
Esta op\cao\ cria um \II ndice das sec\coes\ e a 'Lista dos Programas' na 1\upa\ p\'agina, logo ap\'os a folha de rosto. \'E uma lista com a numera\cao\ e os nomes de todas as sec\coes\ e subsec\coes\ que o relat\'orio tem, seguida da 'Lista dos Programas' (c\'odigo de programa\cao) inclu\ii dos no relat\'orio. Aparecem em letra num tamanho inferior e espa\co\ entrelinhas mais curto, pois o objetivo \'e ocupar pouco espa\co\ na p\'agina inicial}%

\DeclareOption{help}{%
 \setboolean{@helpOpcoes}{true}%
 \setboolean{@helpComandosPreambulo}{true}%
 \setboolean{@helpEnvironments}{true}%
 \setboolean{@helpComandos}{true}%
 \setboolean{@helpPackages}{true}%
}%
\@appendToHelpOpcoes{help}{Help completo}{Esta op\cao\ imprime no in\ii cio do seu texto, a lista de todos os comandos, environments, op\coes\ dispon\ii veis e packages usadas nesta classe, com algumas notas explicativas. %
\textit{Depois deve remov\^e-la} para voltar a ter apenas o seu texto}%

\newboolean{@helpOpcoes}%
\setboolean{@helpOpcoes}{false}%

\DeclareOption{helpOpcoes}{\setboolean{@helpOpcoes}{true}}%
\@appendToHelpOpcoes{helpOpcoes}{Help das op\coes\ desta classe}{%
Pode ver a listagem de todas as op\coes\  no in\ii cio do documento, ou incluindo a macro \texttt{notasExplicativasDasOpcoes} a meio do seu texto (equivalente ao comando \texttt{helpOpcoes}, que d\ao\ a mesma descri\cao\ da op\cao\ \texttt{helpOpcoes}. %
\textit{Depois deve remov\^e-la} para voltar a ter apenas o seu texto}%

\newboolean{@helpComandosPreambulo}%
\setboolean{@helpComandosPreambulo}{false}%

\DeclareOption{helpPreambulo}{\setboolean{@helpComandosPreambulo}{true}}%
\@appendToHelpOpcoes{helpPreambulo}{Comandos \textsl{Obrigat\'orios}}{O estilo \texttt{\@useMyClassName} requer a defini\cao\ de diversos par\^ametros, atrav\'es de comandos obrigat\'orios colocados no pre\^ambulo do documento. Os seus valores  s\ao\ depois inclu\ii dos no documento (nos locais certos) na altura da sua formata\cao\ (compila\cao). %
Pode ver esta listagem usando a macro \@macroName{notasExplicativasDoPreambulo}{}{.} a meio do seu texto (equivalente ao comando \@macroName{helpPreambulo}{}{.}), que d\'a a mesma descri\cao\ da op\cao\ \texttt{helpPreambulo} no in\ii cio do documento. %
\textit{Depois deve remov\^e-la} para voltar a ter apenas o seu texto}%

\newboolean{@helpComandos}%
\setboolean{@helpComandos}{false}%

\DeclareOption{helpComandos}{\setboolean{@helpComandos}{true}}%
\@appendToHelpOpcoes{helpComandos}{Comandos opcionais}{%
O estilo \texttt{\@useMyClassName} fornece alguns comandos de formata\cao\ de texto que facilitam a escrita em \LaTeX. Esta op\cao\ mostra essa lista no in\ii cio do documento, mas pode v\^e-la se incluir o comando  \@macroName{notasExplicativasDosComandos}{}{.} a meio do seu texto (o mesmo que \@macroName{helpComandos}{}{.}). Todos os comandos \texttt{cmd} t\^em um \textit{HELP} pr\'oprio que pode ver se usar \@macroName{HELPcmd}{}{.} em qualquer parte do texto. %
\textit{Depois deve remov\^e-la} para voltar a ter apenas o seu texto}%

\newboolean{@helpPackages}%
\setboolean{@helpPackages}{false}%

\DeclareOption{helpPackages}{\setboolean{@helpPackages}{true}}%
\@appendToHelpOpcoes{helpPackages}{Packages nesta classe}{%
Esta op\cao\ imprime no in\ii cio do seu texto, a lista de todas as packages que s\ao\ inclu\ii das nesta classe, dando poucas indica\coes\ sobre cada uma. %
Para uma explica\cao\ detalhada de cada package deve consultar o %
reposit\'orio oficial em \https{www.ctan.org}. %

Esta mesma listagem pode ser vista usando a macro \@macroName{notasExplicativasPackages}{}{.} a meio do seu texto (equivalente ao comando \@macroName{helpPackages}{}{.}). %
\textit{Depois deve remov\^e-la} para voltar a ter apenas o seu texto}%

\newboolean{@helpEnvironments}%
\setboolean{@helpEnvironments}{false}%
 
\DeclareOption{helpEnvironments}{\setboolean{@helpEnvironments}{true}}%
\@appendToHelpOpcoes{helpEnvironments}{Environments nesta classe}{%
Apresenta no in\ii cio do documento uma lista de todos os \textit{Environments} que foram criados nesta classe. Muitas s\ao\ listas com numera\cao\ romana, em letras ou \`arabe, sempre indentadas um extra \`a esquerda. Tanto as listas como os seus itens podem ter etiquetas pr\'oprias para serem referenciados individualmente.\\ %
Pode ver esta listagem usando a macro \@macroName{notasExplicativasEnvironments}{}{.} a meio do seu texto (equivalente \`a \@macroName{helpEnvironments}{}{.}). %
\textit{Depois deve remov\^e-la} para voltar a ter apenas o seu texto}%

\newboolean{@unix}%
\setboolean{@unix}{false}%
\newboolean{@windows}%
\setboolean{@windows}{true}%

\newboolean{@logoGazeta}%
\setboolean{@logoGazeta}{false}%

\newboolean{@OAL}%
\setboolean{@OAL}{false}%

\newboolean{@protocolo}%
\setboolean{@protocolo}{false}%

\DeclareOption*{\PassOptionsToClass{\CurrentOption}{article}}%

\PassOptionsToClass{a4paper}{article}%

\ProcessOptions\relax%

\LoadClass{article}%

\RequirePackage{caption}%
\@appendToHelpPackages{caption}{Para alterar o formato do texto nas legendas, como as margens, tipo de etiqueta e separador, a sua dist\^ancia ao texto, indenta\cao, justifica\cao, etc. %
Inclui em si a package \texttt{\textbf{subcaption}}.}%

\captionsetup{font={footnotesize,sf}, labelfont=bf, labelsep=period, margin=0.5mm}%

\RequirePackage{subcaption}%
\@appendToHelpPackages{subcaption}{Para ter os \textit{environments} '\texttt{subfigure}' e '\texttt{subtables}' com legendas e labels pr\'oprios. Esta package est\'a integrada na \texttt{\textbf{caption}}. %
Tamb\'em se encontra aqui o comando \texttt{\textbackslash{subfloat}} para compatibilidade com textos mais antigos que usavam a package mais velha \texttt{\textbf{subfig}} (incompat\ii vel com esta). Pode usar o cl\'assico \\ %
\texttt{\textbackslash{subfloat}[legenda]\{\textbackslash{includegraphics}[op\coes,size,pos]\{imagem.png\}\textbackslash{label}\{lbl\}\}}\\ %
ou o comando pr\'oprio e mais moderno que precisa do \@macroName{label}{\{lbl\}}{.} dentro dos primeiros \{ \}, com a legenda:\\ %
\texttt{\textbackslash{subcaptionbox}\{legenda\textbackslash{label}\{lbl\}\}\{\textbackslash{includegraphics}[op\coes,size,pos]\{imagem.png\}\}}.}%

\RequirePackage{enumitem}%
\@appendToHelpPackages{enumitem}{Permite alterar facilmente a numera\cao\ e formata\cao\ de ambientes de lista: \texttt{enumerate}, \texttt{itemize} e \texttt{description}. }%

\definecolor{hyprfRed}{rgb}{0.4,0.01,0.01}%
\definecolor{hyprfGreen}{rgb}{0.05,0.4,0.05}%
\definecolor{hyprfBlue}{rgb}{0.08,0.1,0.08}%
\definecolor{hyprfCyan}{rgb}{0.3,0.03,0.3}%

\RequirePackage[%
 pdfcreator={LaTeX with hyperref package}, %
 pdfpagelayout=OneColumn,%
 pdfstartview=FitH, %
 bookmarks=true,%
 unicode=false,%
 colorlinks=true,%
 linkcolor=hyprfRed,%
 citecolor=hyprfGreen,%
 filecolor=hyprfBlue,%
 urlcolor=hyprfCyan%
]{hyperref}%
\@appendToHelpPackages{hyperref}{inclui hiper-refer\^encias ativas no \texttt{.pdf}, \`as p\'aginas das figuras, tabelas, links, urls, etc. }%

\urlstyle{same}%

\newmuskip\Urlslashmuskip%
\Urlslashmuskip=0mu plus0mu minus2mu%
\g@addto@macro\UrlSpecials{\do\/{\Urlspaceyslash}}%
\def\Urlspaceyslash{\futurelet\Urlssnext\finishUrlspaceyslash}%
\def\finishUrlspaceyslash{%
 \mskip\Urlslashmuskip  %
 \mathchar8239  %
 \ifx\Urlssnext/\mskip-\Urlslashmuskip%
 \else\mskip\Urlslashmuskip\fi %
}%

\ifthenelse{\boolean{@unix}}%
 {\RequirePackage[\@encoding]{inputenc}%
  \RequirePackage{fancyheadings}%
 }%
 {\ifthenelse{\boolean{@windows}}%
   {\RequirePackage[\@encoding]{inputenc}%
    \RequirePackage{fancyhdr}%
   }%
   {\RequirePackage[cp850]{inputenc}%
    \RequirePackage{fancyheadings}%
   }%
 }%
\@appendToHelpPackages{fancyhdr}{The package provides extensive facilities, both for constructing headers and footers, and for controlling their use (for example, at times when LaTeX would automatically change the heading style in use).%
Note-se que a alternativa \texttt{fancyheadings} \'e considerada obsoleta e deve ser evitada. }%
\@appendToHelpPackages{inputenc}{Usa descri\coes\ de caracteres que s\ao\ corretamente apresentadas pelo 'fontencoding', escolhido com a package \texttt{fontenc}. Numa file sua use: \texttt{$\backslash$usepackage[xx]\{inputenc\}} onde \texttt{xx=utf8} ou \texttt{latin1}, mas deve estar \uline{\textit{depois}} do comando %
\@macroName[Btt]{usepackage}{[T1]}{\{fontenc\}}. %
\textit{A ordem \'e importante}\relax. }%

\RequirePackage{listings}%
\@appendToHelpPackagesXtras{listings}{Esta package permite incluir c\'odigo de programa\cao\ em muitas linguagens (C, Python, Mathematica, Java, awk, Askell, etc.), que aparece dentro duma caixa colorida pr\'opria e com os comandos da linguagem e estruturas real\cc adas em cores diferentes. Este estilo \'e default mas se passar para outro pode cham\'a-lo com '\texttt{style=programa}'. O c\'odigo p\oe-se dentro do \textit{environment}:%
\@explicaEnvironment[]{language=c, label=\textit{prg:lbl}, caption=\{legenda\}}%
{lstlisting}{\\ \textit{c\'odigo do meu programa}}.\\ %
O uso do label tipo \texttt{prg:lbl} permite que o comando \@macroName{referir}{\{prg:lbl\}}{.} insira a refer\^encia ``\textit{programa Pn.m (p\'ag. pp)}''\ no texto.}%

\renewcommand{\l@lstlisting}[2]{%
  \@dottedtocline{1}{0em}{3.5em}{\lstlistingname\ #1}{#2}}%

\definecolor{codegreen}{rgb}{0,0.6,0}%
\definecolor{codegray}{rgb}{0.5,0.5,0.5}%
\definecolor{darkgray}{rgb}{0.3,0.3,0.3}%
\definecolor{codepurple}{rgb}{0.58,0,0.82}%
\definecolor{backcolour}{rgb}{0.95,0.95,0.92}%

\lstdefinestyle{programa}{%
    backgroundcolor=\color{backcolour},%
    commentstyle=\color{codegreen},%
    keywordstyle=\color{magenta},%
    numberstyle=\tiny\color{codegray},%
    stringstyle=\color{codepurple},%
    basicstyle=\footnotesize\fontfamily{fvm}\selectfont,%
    breakatwhitespace=false,%
    breaklines=true,%
    captionpos=t, %
    keepspaces=true, %
    numbers=left,%
    numbersep=3pt,%
    showspaces=false,%
    showstringspaces=false,%
    showtabs=false,%
    tabsize=2,%
    frame=none,%
    aboveskip=\smallskipamount,%
    lineskip=3pt,%
    extendedchars=true%
}%
\lstset{style=programa}%
 
\renewcommand{\lstlistingname}{}%
\renewcommand{\lstlistlistingname}{Lista de Programas}%

\DeclareCaptionFormat{tipo1CaptionProg}{\vskip -3mm\rule{2.5cm\relax}{0.4pt} \par\vskip 3pt #1#2#3}%

\DeclareCaptionFormat{tipo2CaptionProg}{\vskip 3pt\par\vskip 3pt\hskip 1pt #1#2#3}%

\captionsetup[lstlisting]{format=tipo2CaptionProg, font={footnotesize,sf},   %
 labelsep=space, labelfont=bf, singlelinecheck=false}%

\RequirePackage{commath}%
\@appendToHelpPackagesXtras{commath}{Esta package define comandos matem\'aticos com boa formata\cao. %
Por exemplo o comando de derivada ordin\'aria em modo de texto \@macroName{tod}{[2]\{f\}\{x\}}{.} produz os operadores diferenciais em fonte serifada: \tod[2]{f}{x}. A vers\ao\ Display Mode \'e \@macroName{dod}{[2]\{f\}\{x\}}{.}. %
O comando \@macroName{tpd}{\{f\}\{x\}}{.} cria uma derivada parcial \tpd{f}{x} em modo de texto e \@macroName{dpd}{[2]\{f\}\{x\}}{.} aparece em Display Mode. %
The commath-package provides commands for delimiters for which the size is determined automatically by default or can be controlled by an integer argument. Thus, the size of delimiters can be adapted to the formula by just changing one integer argument.\\ %
Pode ver a descri\cao\ completa em %
\http{mirrors.ctan.org/macros/latex/contrib/commath/commath.pdf}. %
}%

\RequirePackage[bottom]{footmisc}%
\@appendToHelpPackagesXtras{footmisc}{Esta package coloca os 'footnote' no final da p\'agina. Tem v\'arias op\coes\ poss\ii veis mas s\'o se usa a \texttt{[bottom]}. %
Pode ver a descri\cao\ completa em %
\https{mirrors.up.pt/pub/CTAN/macros/latex/contrib/footmisc/footmisc.pdf}. %
}%

\setlength{\textheight}{243mm}%
\setlength{\topmargin}{-15mm}%

\ifthenelse{\boolean{@OAL}}%
 {\setlength{\textwidth}{170truemm}%
  \setlength{\oddsidemargin}{-2mm}%
  \setlength{\topmargin}{-15mm}%
 }%
 {\ifthenelse{\boolean{@protocolo}}%
  {\setlength{\voffset}{-26mm}%
   \setlength{\topmargin}{0mm}%
   \setlength{\headheight}{2mm}%
   \setlength{\headsep}{0pt}%
   \setlength{\textheight}{259mm}%
   \setlength{\footskip}{11mm}%
   \setlength{\hoffset}{-7mm}%
   \setlength{\oddsidemargin}{-0mm}%
   \setlength{\textwidth}{174truemm}%
  }%
  {\setlength{\textwidth}{174truemm}%
  \setlength{\oddsidemargin}{-6mm}%
  }%
 }%

\lhead{\scriptsize\textsf{\@NomeCursoShort}}%

\ifthenelse{\boolean{@logoGazeta}}%
 {\chead{\cheadGazeta}%
  \rhead{\rheadGazeta}%
  \lhead{\lheadGazeta}%
 }%
 {%
  \ifthenelse{\boolean{@OAL}}%
   {\defineOALfancyPageStyles%
    \chead{\cheadOAL}%
   }%
   \ifthenelse{\boolean{@protocolo}}%
   {\defineProtocolofancyPageStyles%
    \chead{\cheadProtocolo}%
   }%
   {\chead{\includegraphics[height=6mm]{ciencias_ul_azul_h_sass.png}}%
   \rhead{\scriptsize\textsf{\@anocurso}}%
   }%
 }%
 
\lfoot{\scriptsize\textsf{{\bfseries\@NomeCurtoTrabalhoLab}, \tiny\@nomesAutores}}%
\rfoot{\scriptsize\textsf{p\'ag. \arabic{page} de \zref[abspage]{LastPage}}}%

\newcommand{\rodapeComVersao}%
  {\hspace*{70truemm}\fontsize{4pt}{4pt}\selectfont\LaTeX\  \textsf{\@versaoNum}}%

\ifthenelse{\boolean{@OAL}}%
 {\fancyfoot[C]{}}%
 {\fancyfoot[C]{%
    \iffancylastpage{\rodapeComVersao}{}%
  }%
 }%
 
\newcommand*\varhrulefill[1]{\leavevmode\leaders\hrule height#1\hfill\kern0pt}%

\ifthenelse{\boolean{@logoGazeta}}{%
\renewcommand{\headrule}{\headruleGazeta} %
}%
{\ifthenelse{\boolean{@OAL}}{%
  \renewcommand{\headrule}{\headruleOAL}%
 }%
 {}%
}%

\ifthenelse{\boolean{@windows}}%
   {\ifthenelse{\boolean{@protocolo}}%
     {\renewcommand{\footrulewidth}{0.2pt}%
      \renewcommand{\plainfootrulewidth}{0.2pt}}%
     {%
      \renewcommand{\footrulewidth}{0.pt}%
      \renewcommand{\plainfootrulewidth}{0.pt}}%
    \setlength{\headheight}{15mm}%
    \ifthenelse{\boolean{@OAL}}%
     {\renewcommand{\headsep}{7mm}}%
     {}%
    \ifthenelse{\boolean{@protocolo}}%
     {\renewcommand{\headsep}{7mm}}%
     {}%
   }%
   {%
    \footrulewidth 0.pt%
    \plainfootrulewidth 0.pt %
    \headheight 19mm%
   }%

\ifthenelse{\boolean{@protocolo}}%
{\renewcommand{\thesection}{Experi\^encia \arabic{section} --}%

\newcounter{itemPrgt}[section]%
\renewcommand{\theitemPrgt}{\arabic{section}.\arabic{itemPrgt}}%
 
\newcommand{\itemPrgt}[1][]{%
 \refstepcounter{itemPrgt}%
 \item[\textbf{P\theitemPrgt~}] %
   \IfStrEq{#1}{}{}{\label{#1}}%
}%

\@appendToHelpCmd[section]{\{txt\}}{Protocolo}{ Este comando passa a ter a designa\cao\ de  \textit{Experi\^encia n}. N\ao\ est\ao\ definidos nomes diferentes para as subsec\coes. Numa sec\cao\ existem Perguntas (numeradas) que s\ao\ iniciadas com o \textit{environment} \@macroName{begin}{\{perguntas\}}{.}. Cada pergunta inicia-se com \@macroName{itemPrgt}{[pg:lbl]}, etc.}{Opcionais}%
\@appendToHelpCmd[itemPrgt]{[pg:lbl]}{Protocolo}{ Cria uma pergunta numerada do tipo \texttt{Pn.m} dentro do ambiente \@macroName{begin}{\{perguntas\}}{.}. O \texttt{pg:lbl} \'e opcional mas, se existir e come\ca r por \texttt{pg}, o comando \@macroName{referir}{\{pg:lbl\}}{.} reconhece-o e escreve \textsl{pergunta Pn.m (p\'ag.\ nn)}.}{Opcionais}%
}%
{}%

\setlength{\parindent}{4mm}%
\setlength{\parskip}{2mm}%
\renewcommand{\baselinestretch}{1.05}%
\selectfont %

\newcommand{\@NomeDepartamento}{Departamento de F\ii sica}%
\newcommand{\@NomeDepartamentoShort}{Dep.\ F\ii sica}%
\newcommand{\Instituicao}[2][\ ]{%
  \IfStrEq{#2}{}%
   {\renewcommand{\@NomeDepartamento}{\ }}%
   {\renewcommand{\@NomeDepartamento}{#2}}%
  \renewcommand{\@NomeDepartamentoShort}{#1}%
}%
\@appendToHelpPeambulo[Instituicao]{\{nome completo\}}%
{Institui\cao}{no pre\^ambulo do LaTeX. Est\'a pr\'e-definido como "Departamento de F\ii sica". O \texttt{nome completo} parece na folha de rosto. Se quiser mudar o nome defina-o com este comando. Para limpar esta linha na folha de rosto use como \texttt{nome completo} a sequ\^encia \{\textbackslash\textvisiblespace\}.%
}%

\newcommand{\@NomeCurso}{F\ii sica Experimental I}%
\newcommand{\@NomeCursoShort}{Fis.\ Exp.\ 1}%
\newcommand{\NomeDoCurso}[2][\ ]{%
  \IfStrEq{#2}{}%
   {\renewcommand{\@NomeCurso}{\ }}%
   {\renewcommand{\@NomeCurso}{#2}}%
  \renewcommand{\@NomeCursoShort}{#1}%
}%
\@appendToHelpPeambulo[NomeDoCurso]{[nome abreviado]\{nome completo\}}%
{Nome do Curso}{no pre\^ambulo do LaTeX. Est\'a pr\'e-definido como "F\ii sica Experimental I". O \texttt{nome completo} parece na folha de rosto e o \texttt{nome abreviado} aparece no cabe\ca lho esquerdo de cada p\'agina. Se quiser mudar o nome da disciplina use este comando. Para limpar esta linha na folha de rosto use como \texttt{nome completo} a sequ\^encia \{\textbackslash\textvisiblespace\}.%
}%

\newcommand{\@NomeTrabalhoLab}{defina o Nome do Trabalho Laboratorial executado}%
\newcommand{\@NomeCurtoTrabalhoLab}{defina o Nome CURTO do Trabalho Laboratorial executado}%
\newcommand{\nomeDoTrabalho}[2][]{%
 \renewcommand{\@NomeTrabalhoLab}{#2}%
 \IfStrEq{#1}{}%
 {\renewcommand{\@NomeCurtoTrabalhoLab}{#2}}%
 {\renewcommand{\@NomeCurtoTrabalhoLab}{#1}}%
}%
\@appendToHelpPeambulo[nomeDoTrabalho]{[nome curto]\{nome completo\}}{Nome do Trabalho Laboratorial}{no pre\^ambulo do LaTeX. \'E obrigat\'orio definir o Nome Curto (usado em rodap\'e) e o nome Completo do Trabalho Laboratorial executado%
}%

\@appendToHelpPeambulo[autorX]{[IDfcul]\{nome\}}{Autor ID}{no pre\^ambulo do LaTeX. \'E obrigat\'orio identificar pelo menos o \texttt{autorA}, incluindo o n\'umero de aluno \texttt{IDfcul} e o \textit{nome} do autor. Podem haver at\'e 4 autores pois X=A, B, C e D. Com a op\cao\ \texttt{paper} o valor dos diversos \texttt{IDfcul} aparecer\ao\ listados em rodap\'e na p\'agina de rosto. Neste caso, pode colocar no campo \texttt{IDfcul} o email de contacto da pessoa, outra identifica\cao\ relevante ou simplesmente omitir.%
}%

\newcommand{\@dataReport}{defina a data do relat\'orio, ex: 23 de Abril}%
\newcommand{\dataDoRelatorio}[1]{\renewcommand{\@dataReport}{#1}}%
\@appendToHelpPeambulo[dataDoRelatorio\{data\}]{}{Data do Relat\'orio}{no pre\^ambulo do LaTeX. \'E obrigat\'orio identificar a data em que foi entregue o relat\'orio. ex: 23 de Abril%
}%

\newcommand{\@anocurso}{2017}%
\newcommand{\ano}[1]{\renewcommand{\@anocurso}{#1}}%
\@appendToHelpPeambulo[ano\{numeral\}]{}{Ano civil}{no pre\^ambulo %
do LaTeX. \'E obrigat\'orio definir o ano civil da disciplina.%
}%

\newcommand{\@turmaNumber}{PL-XX}%
\newcommand{\Turma}[1]{\renewcommand{\@turmaNumber}{#1}}%
\@appendToHelpPeambulo[Turma\{PL-nn\}]{}{Turma do Lab}{no pre\^ambulo do LaTeX. \'E obrigat\'orio identificar a turma Pr\'atica Laboratorial. ex: PL-22.%
}%

\newcommand{\@grupoNumber}{XX}%
\newcommand{\GrupoNum}[1]{\renewcommand{\@grupoNumber}{#1}}%
\@appendToHelpPeambulo[GrupoNum\{numeral\}]{}{N\'umero do Grupo}{no pre\^ambulo do LaTeX. \'E obrigat\'orio identificar o n\'umero do grupo na turma Pr\'atica.%
}%

\newcommand{\@dataAulaLab}{XX de Mar\co}%
\newcommand{\dataAulaLaboratorial}[1]{%
 \renewcommand{\@dataAulaLab}{#1}%
}%
\@appendToHelpPeambulo[dataAulaLaboratorial\{data\}]{}{Data da aula Laboratorial}{no pre\^ambulo do LaTeX. \'E obrigat\'orio identificar a data da aula. ex: 23 de Abril%
}%

\newcommand{\@professor}{O nome do professor}%
\newcommand{\NomeDocenteLab}[1]{\renewcommand{\@professor}{#1}}%
\@appendToHelpPeambulo[NomeDocenteLab\{nome\}]{}{Nome do docente}{no pre\^ambulo do LaTeX. \'E obrigat\'orio definir o nome do/a docente que d\'a as aulas de laborat\'orio.%
}%

\newcommand{\@autorA}{}%
\newcommand{\@autorB}{}%
\newcommand{\@autorC}{}%
\newcommand{\@autorD}{}%
\newcommand{\@autorAid}{}%
\newcommand{\@autorBid}{}%
\newcommand{\@autorCid}{}%
\newcommand{\@autorDid}{}%

\providecommand{\autorA}[2][]{%
  \renewcommand{\@autorA}{#2}%
  \renewcommand{\@autorAid}{#1}%
  \newcommand{\@nomesAutores}{#2}%
  \ifthenelse{\equal{#1}{}}%
   {\newcommand{\@nomesAutorMarcas}{#2}}%
   {\newcommand{\@nomesAutorMarcas}{#2$^*$}}%
  \@appendToEmailAutores[*]{#1}%
  \newcommand{\@listAutoresComID}{#2, {\small n.#1}}%
}%

\providecommand{\autorB}[2][]{%
  \renewcommand{\@autorB}{#2}%
  \renewcommand{\@autorBid}{#1}%
}%
\providecommand{\autorC}[2][]{%
  \renewcommand{\@autorC}{#2}%
  \renewcommand{\@autorCid}{#1}%
}%
\providecommand{\autorD}[2][]{%
  \renewcommand{\@autorD}{#2}%
  \renewcommand{\@autorDid}{#1}%
}%

\newcommand{\@emailAutores}{}%

\newcommand{\@appendTolistAutoresComID}[2]{\expandafter\def\expandafter\@listAutoresComID\expandafter{\@listAutoresComID\\ & #1, {\small n.#2}}%
}%

\providecommand{\@appendToNomesAutorMarcas}[3][]{%
  \ifthenelse{\equal{#2}{}}%
   {\ifthenelse{\equal{\@nomesAutorMarcas}{}}%
     {\edef\@nomesAutorMarcas{#3}}%
     {\expandafter\edef\expandafter\@nomesAutorMarcas{\@nomesAutorMarcas, #3}}%
   }%
   {\ifthenelse{\equal{\@nomesAutorMarcas}{}}%
     {\edef\@nomesAutorMarcas{#3\ensuremath{^{#1}}}}%
     {\expandafter\edef\expandafter\@nomesAutorMarcas{\@nomesAutorMarcas, #3\ensuremath{^{#1}}}%
     }%
   }%
}%

\providecommand{\@appendToEmailAutores}[2][]{%
 \ifthenelse{\equal{\@emailAutores}{}}%
  {\ifthenelse{\equal{#2}{}}{}%
   {\expandafter\edef\expandafter\@emailAutores{\ensuremath{^{#1}}#2}}%
  }%
  {\ifthenelse{\equal{#2}{}}{}%
   {\expandafter\edef\expandafter\@emailAutores{\@emailAutores, \ensuremath{^{#1}}#2}}%
  }%
}%

\newcommand{\@incluiAutorNasListas}[3][]{%
  \ifthenelse{\equal{#3}{}}{}%
  {%
   \@appendTolistAutoresComID{#3}{#2}%
   \edef\@nomesAutores{\@nomesAutores, #3}%
   \@appendToEmailAutores[#1]{#2}%
   \@appendToNomesAutorMarcas[#1]{#2}{#3}%
  }%
}%

\newcommand{\@makeAutores}{%
 \@incluiAutorNasListas[\dagger]{\@autorBid}{\@autorB}%
 \@incluiAutorNasListas[\ddagger]{\@autorCid}{\@autorC}%
 \@incluiAutorNasListas[\dagger\dagger]{\@autorDid}{\@autorD}%
}%

\newcommand{\listaAutores}{\@nomesAutores}%
\newcommand{\listaAlunos}{\@nomesAutores}%
\@appendToHelpCmd[listaAutores]{\ }{Lista de Autores}{no meio do seu texto, para referenciar de um modo r\'apido os nomes dos autores. Lista do tipo: \texttt{autorA, autorB, autorC}. Esta lista tamb\'em parece no rodap\'e esquerdo das p\'aginas.%
}{Opcionais}%

\newenvironment{referencias}%
 {\vspace*{-1mm}%
 \begin{thebibliography}{1}%
 \small%
 \itemsep -0.3mm%
 \vspace*{-3mm}%
 }%
 {\end{thebibliography}}%

\definecolor{azulFCUL}{cmyk}{1,0.68,0,0.12}%

\newcommand{\@textoGrupo}{%
\ifthenelse{\equal{\@grupoNumber}{}}%
 {}%
 {\small$-$ grupo \@grupoNumber}%
}%

\newcommand{\blankfootnote}[1]{{%
  \renewcommand{\thefootnote}{\fnsymbol{footnote}}%
  \footnotetext[0]{#1}%
}}%

\newcommand{\@sbRule}[2][mm]{\rule{#2#1}{0.4pt}}%

\newcommand{\@nomesTituloPagInicial}{%
\ifthenelse{\boolean{@artigo}}%
{\textsc{%
{\normalsize\ }\\[10mm]%
\LARGE\@NomeTrabalhoLab\\[15mm]%
 {\large\@NomeCurso}\\[1mm]%
 {\normalsize \@NomeDepartamento}\\[19mm]%
} %
\large%
\author{\@nomesAutorMarcas}%
\ifthenelse{\equal{\@emailAutores}{}}{}%
   {\blankfootnote{\@emailAutores}}%
}%
{%
 \ifthenelse{\boolean{@protocolo}}%
 {\textsc{{\large\bfseries Protocolo do Trabalho Laboratorial \@protocoloID}\\[8mm]%
   \@NomeTrabalhoLab\\[10mm]%
   {\large\@NomeCurso}\\[3mm]%
   {\large\@NomeDepartamento}\\[35mm]%
  }%
  \fss\large%
  \begin{tabular}{llr}%
   Nome: \@sbRule{85} & n\upo\@sbRule{18} &\hfill Turma PL \@sbRule{12}\\[6mm]%
   Nome: \@sbRule{85} & n\upo\@sbRule{18} &\hfill Grupo \@sbRule{12}\\[6mm]%
   Nome: \@sbRule{85} & n\upo\@sbRule{18} &\hfill Data: \@sbRule{8}/\@sbRule{10}\\ %
    & &  \\[10mm]%
   \hfill\normalsize Docente: & &\\ %
  \end{tabular}%
  \author{}%
 }%
 {%
  \textsc{{\normalsize Relat\'orio do Trabalho Experimental}\\[4mm]%
  \@NomeTrabalhoLab\\[9mm]%
   {\Large\@NomeCurso\ --\ \@anocurso}\\[1mm]%
   {\large \@NomeDepartamento}\\[19mm]%
   } %
  \large%
  \begin{tabular}{l r}%
   Grupo: & \@listAutoresComID\\[3mm]%
   Turma: & \@turmaNumber\@textoGrupo\\[3mm]%
   Aula de: & {\small\@dataAulaLab}\\[3mm]%
   \normalsize Docente: & \normalsize\@professor%
  \end{tabular}%
  \author{}%
 }%
}%
}%

\title{%
\ifthenelse{\boolean{@logoGazeta}}%
 {\paginaUmGazeta}%
 {\ifthenelse{\boolean{@OAL}}%
  {\paginaUmOAL}%
  {\ifthenelse{\boolean{@protocolo}}%
    {\paginaUmProtocolo}%
    {\includegraphics[height=29mm]{ciencias_ul_azul_h.png}\\[-5mm]%
    \textcolor{azulFCUL}{\noindent\varhrulefill{0.4mm}}\\[42mm]%
    \@nomesTituloPagInicial}%
  }%
 }%
}%

\vfill%
\ifthenelse{\boolean{@protocolo}}%
 {\date{\vspace*{10mm}\@anocurso}}%
 {\date{\small\@dataReport, \@anocurso}}%
 
\AtBeginDocument{%
\ifthenelse{\boolean{@protocolo}}%
 {\IfStrEq{\@autorA}{}%
   {\autorA{\@professor}}%
   {}%
 }%
 {}%

\@makeAutores%
  
\ifthenelse{\boolean{@OAL}}{\@PDFinfoOAL}%
 {\ifthenelse{\boolean{@logoGazeta}}{\@PDFinfoGazeta}%
  {\newcommand{\@PDFsubject}{Relat\'orio de \@NomeCurso, \@anocurso, FCUL}%
   \newcommand{\@PDFkeywords}{{An\'alise de dados,}{ F\ii sica Experimental,}{ estat\ii stica}}%
  }%
 }%

\ifthenelse{\equal{\@pdfassunto}{}}%
  {}%
  {\renewcommand{\@PDFsubject}{\@pdfassunto}}%
  
\ifthenelse{\equal{\@pdfkeyword}{}}%
  {}%
  {\renewcommand{\@PDFkeywords}{\@pdfkeyword}}%

\ifthenelse{\equal{\@pdftitulo}{}}%
  {\newcommand{\@PDFtitle}{\@NomeTrabalhoLab}}%
  {\newcommand{\@PDFtitle}{\@pdftitulo}}%

\ifthenelse{\equal{\@pdfautor}{}}%
  {\newcommand{\@PDFauthors}{\@nomesAutores}}%
  {\newcommand{\@PDFauthors}{\@pdfautor}}%
 
\hypersetup{%
 pdftitle={\@PDFtitle},%
 pdfauthor={\@PDFauthors},%
 pdfsubject={\@PDFsubject},%
 pdfkeywords={\@PDFkeywords},%
 pdfproducer={\@myClassName.cls \@versaoNum\ de Rui J. Agostinho}%
}%

\maketitle%
\thispagestyle{empty}%
\newpage%

\begingroup%
 \fontencoding{T1}\fontfamily{lmss}\fontseries{m}\fontshape{n}\fontsize{10}{1.1em}%
 \selectfont%
 
 \ifthenelse{\boolean{@helpOpcoes}}%
  {\begin{description}%
    \@helpTxtOpcoes%
   \end{description}%
  }%
  {}%
 \ifthenelse{\boolean{@helpComandosPreambulo}}%
  {\@helpTxtComandosPeambulo}%
  {}%
 \ifthenelse{\boolean{@helpComandos}}%
  {\@helpTxtComandosOpcionais%
   \@helpTxtComandosMatematicos%
   \@helpTxtComandosFigsTabs%
   \@helpTxtComandosReferir%
  }%
  {}%
 \ifthenelse{\boolean{@helpPackages}}%
  {\@helpTxtPackages \@helpTxtPackagesXtras}%
  {}%
 \ifthenelse{\boolean{@helpEnvironments}}%
  {\@helpTxtEnvironments}%
  {}%
\endgroup%

\pagestyle{fancy}%
\ifthenelse{\boolean{@OAL}}%
 {\pagestyle{papelTimbradoOAL}}%
 {\ifthenelse{\boolean{@protocolo}}%
  {\pagestyle{papelTimbradoProtocolo}}%
  {}%
 }%

\renewcommand\lstlistoflistings{%
 \section*{\lstlistlistingname}%
 \@mkboth{\lstlistlistingname}%
         {\lstlistlistingname}%
 \@starttoc{lol}%
}%
  
\ifthenelse{\boolean{@indice}}%
 {\setstretch{0.7}%
 \footnotesize\tableofcontents%
 \normalsize%
 \setstretch{1.05}}%
 {}%
 \ifthenelse{\boolean{@indicePrg}}%
 {\setstretch{0.7}\footnotesize%
 \tableofcontents\lstlistoflistings%
 \normalsize\setstretch{1.05}}%
 {}%
}%

\providecommand{\ii}{\'\i}%
\providecommand{\coes}{\-\c{c}\~{o}\-es}%
\providecommand{\coestt}{\-\c{c}\~{o}\-es}%
\providecommand{\cao}{\-\c{c}\~{a}o}%
\providecommand{\caott}{\-\c{c}\~{a}o}%
\providecommand{\oe}{\~{o}e}%
\renewcommand{\oe}{\~{o}e\xspace}%
\providecommand{\oestt}{\~{o}es}%
\providecommand{\oes}{\~{o}es\xspace}%
\providecommand{\aes}{\~{a}es\xspace}%
\providecommand{\aestt}{\~{a}es}%
\providecommand{\ae}{\~{a}e}%
\renewcommand{\ae}{\~{a}e}%
\providecommand{\ao}{\~{a}o\xspace}%
\providecommand{\co}{\-\c{c}o}%
\providecommand{\ca}{\-\c{c}a}%
\providecommand{\sao}{\-s\~{a}o\xspace}%
\providecommand{\soes}{\-s\~{o}es\xspace}%
\providecommand{\sae}{\-s\~{a}e\xspace}%
\providecommand{\saes}{\-s\~{a}es\xspace}%
\providecommand{\cc}{\c{c}}%
\renewcommand{\cc}{\c{c}}%
\providecommand{\me}{\--me\xspace}%
\providecommand{\se}{\--se\xspace}%
\providecommand{\te}{\--te\xspace}%
\providecommand{\la}{\--la\xspace}%
\providecommand{\lhe}{\--lhe\xspace}%
\providecommand{\nos}{\--nos\xspace}%

\providecommand{\II}{\'I}%
\providecommand{\COES}{\-\c C\~{O}ES\xspace}%
\providecommand{\CAO}{\-\c{C}\~{A}O\xspace}%
\providecommand{\OE}{\~{O}E}%
\renewcommand{\OE}{\~{O}E}%
\providecommand{\OES}{\~{O}ES\xspace}%
\providecommand{\AES}{\~{A}ES\xspace}%
\renewcommand{\AE}{\~{A}E}%
\providecommand{\AO}{\~{A}O}%
\providecommand{\CO}{\-\c{C}O}%
\providecommand{\CA}{\-\c{C}A}%
\providecommand{\SAO}{\-S\~{A}O\xspace}%
\providecommand{\SOES}{\-S\~{O}ES\xspace}%
\providecommand{\SAES}{\-S\~{A}ES\xspace}%
\providecommand{\CC}{\c{C}}%
\providecommand{\ME}{\--ME\xspace}%
\providecommand{\SE}{\--SE\xspace}%
\providecommand{\TE}{\--TE\xspace}%
\providecommand{\LA}{\--LA\xspace}%
\providecommand{\LHE}{\--LHE\xspace}%
\providecommand{\NOS}{\--NOS\xspace}%

\newcommand{\Oal}{Observat\'orio Astron\'omico de Lisboa}%
\newcommand{\OAL}{\Capitalize{\Oal}}%
\newcommand{\Oale}{Astronomical Observatory of Lisbon}%
\newcommand{\OALe}{\Capitalize{\Oale}}%
\newcommand{\Fcul}{Faculdade de Ci\^encias da Universidade de Lisboa}%
\newcommand{\Fculx}{Faculdade de Ci\^encias da ULisboa}%
\newcommand{\FcUl}{\Fculx}%
\newcommand{\FCUL}{\Capitalize{\Fcul}}%
\newcommand{\Fcule}{Faculty of Sciences of the University of Lisbon}%
\newcommand{\Fculxe}{Faculty of Sciences of ULisboa}%
\newcommand{\FCULe}{\Capitalize{\Fcule}}%

\@appendToHelpAbreviaturas{Fcul}%
\@appendToHelpAbreviaturas{FcUl}%
\@appendToHelpAbreviaturas{FCUL}%

\newcommand{\GdF}{Gazeta de F\ii sica}%
\newcommand{\GDF}{\Capitalize{\GdF}}%
\newcommand{\Gazeta}{\GdF}%

\providecommand{\bfss}{\bfseries\sffamily}%
\providecommand{\bfssm}{\bfseries\small\sffamily}%
\providecommand{\bfssf}{\bfseries\footnotesize\sffamily}%
\providecommand{\bfssc}{\bfseries\scriptsize\sffamily}%
\providecommand{\bfsst}{\bfseries\tiny\sffamily}%
\providecommand{\fss}{\sffamily}%
\providecommand{\fssm}{\small\sffamily}%
\providecommand{\fssf}{\footnotesize\sffamily}%
\providecommand{\fssc}{\scriptsize\sffamily}%
\providecommand{\fsst}{\tiny\sffamily}%

\newcommand{\@fontesize}[2]{%
    		#2\fontsize{#1}{\baselineskip}\selectfont}%
    		
\newcommand{\@fontebssize}[1]{%
    		\bfss\fontsize{#1}{\baselineskip}\selectfont}%
\newcommand{\@fontessize}[1]{%
    		\fss\fontsize{#1}{\baselineskip}\selectfont}%

\newcommand{\Capitalize}[1]{\texorpdfstring{\expandafter\MakeTextUppercase\expandafter{#1}}{}}%

\newenvironment{@textoNotaExpl}[2][Nota Explicativa:]%
{\ifthenelse{\equal{#2}{}}{%
 \fontfamily{lmss}\selectfont\noindent%
 \ifthenelse{\equal{#1}{}}{}{\paragraph{\fontfamily{lmss}\selectfont #1}}%
 }%
 {#1}%
}{\par}%

\newcommand{\notasExplicativasDasOpcoes}[1][]{ %
\begin{@textoNotaExpl}[]{#1}%
Nas \@macroName[]{varias,outras,opcoes,uteis}{}{.} inclui-se um n\'umero restrito de op\coes\ %
que podem ser usadas. Neste estilo foram criadas as seguintes op\coes, apresentadas em baixo.%
Pode ver esta mesma listagem incluindo a macro \texttt{notasExplicativasDasOpcoes} a meio do seu texto (equivalente ao comando \texttt{helpOpcoes}), %
que d\'a a mesma descri\cao\ da op\cao\ \texttt{helpOpcoes} no in\ii cio do documento.%

\vspace*{3mm}\noindent%
\underline{\textsc{Op\coes\ dispon\ii veis na classe}} '\texttt{\@myClassName}'%
\begin{description}[font=\ttfamily]%
\@helpTxtOpcoes%
\end{description}%
\end{@textoNotaExpl}}%

\newcommand{\helpOpcoes}{\vspace*{3mm}\noindent%
\underline{\textsc{Op\coes\ dispon\ii veis na classe}} '\texttt{\@myClassName}'%
\begin{description}[font=\ttfamily]%
\@helpTxtOpcoes%
\end{description}}%

\newcommand{\notasExplicativasDosComandos}[1][]{ %
\begin{@textoNotaExpl}[]{#1}%
Este estilo de relat\'orio fornece alguns comandos de formata\cao\ de texto que facilitam a escrita em \LaTeX. Pode ver esta mesma listagem incluindo a macro \@macroName{notasExplicativasDosComandos}{}{.} a meio do seu texto (equivalente ao comando \@macroName{helpComandos}{}{.}), %
que d\'a a mesma descri\cao\ da op\cao\ \texttt{helpComandos} no in\ii cio do documento. %

\noindent\textbf{HELP}: todos os comandos (nome \texttt{cmd}) t\^em um \textit{help} pr\'oprio que pode ver se usar \texttt{$\backslash$HELPcmd} em qualquer parte do texto. %
Isso permite tirar d\'uvidas sobre a sua utiliza\cao\ sem sair do documento.%

\@helpTxtComandosOpcionais%

\@helpTxtComandosMatematicos%

\@helpTxtComandosFigsTabs%

\@helpTxtComandosReferir%

\@helpTxtAbreviaturas%
\end{@textoNotaExpl}}%
\newcommand{\helpComandos}[1][]{\notasExplicativasDosComandos[#1]}%

\newcommand{\helpAbreviaturas}{\@helpTxtAbreviaturas}%

\newcommand{\notasExplicativasDoPreambulo}[1][]{%
\begin{@textoNotaExpl}[]{#1}%
O estilo \texttt{\@myClassName} requer a defini\cao\ de diversos %
par\^ametros, que depois s\ao\ inclu\ii dos no documento na altura da sua %
formata\cao\ (compila\cao).%
Pode ver esta mesma listagem incluindo a macro \@macroName{notasExplicativasDoPreambulo}{}{.} a meio do seu texto (equivalente a usar o comando \@macroName{helpPreambulo}{}{.}), que d\'a a mesma descri\cao\ da op\cao\ \texttt{helpPreambulo} no in\ii cio do documento.%

\@helpTxtComandosPeambulo%
\end{@textoNotaExpl}}%
\newcommand{\helpPreambulo}[1][]{\notasExplicativasDoPreambulo[#1]}%

\newcommand{\notasExplicativasPackages}[1][]{%
\begin{@textoNotaExpl}[]{#1}%
O estilo \texttt{\@myClassName} inclui logo uma variedade de packages %
que facilitam a formata\cao\ do \LaTeX, e que tamb\'em ficam dispon\ii veis para o %
utilizador. %
Segue-se a lista de todas as packages que s\ao\ inclu\ii das, com brev\ii ssimas %
indica\coes\ sobre cada uma. %
Esta mesma listagem pode ser vista usando a macro \@macroName{helpPackages}{}{.} a meio do seu texto (equivalente a \@macroName{notasExplicativasPackages}{}{.}), que d\'a a mesma descri\cao\ da op\cao\ \texttt{helpPackages} no in\ii cio do documento.%

\@helpTxtPackages%
\@helpTxtPackagesXtras%
\end{@textoNotaExpl}%
}%
\newcommand{\helpPackages}[1][]{\notasExplicativasPackages[#1]}%

\newcommand{\notasExplicativasEnvironments}[1][]{%
\begin{@textoNotaExpl}[]{#1}%
A classe \texttt{\@myClassName} inclui uma pequena cole\cao\ de \textit{Environments} que foram criados para facilitar a formata\cao\ do \LaTeX. S\ao\ listas com numera\cao\ romana, em letras ou \'arabe. Todas elas com as etiquetas dos itens indentadas um extra \`a esquerda. Tanto as listas como os seus itens podem ter labels pr\'oprias para serem referenciados individualmente.%
Segue-se a listagem de todos os \textit{Environments}, que tamb\'em  pode ser vista usando a macro \@macroName{notasExplicativasEnvironments}{}{.} a meio do seu texto (equivalente a \@macroName{helpEnvironments}{}{.}), que d\'a a mesma descri\cao\ da op\cao\ \texttt{helpEnvironments} no in\ii cio do documento.%

\noindent\textbf{HELP}: todos os \textit{Environments} (nome \texttt{env}) t\^em um \textit{help} pr\'oprio que pode ver se usar \texttt{$\backslash$HELPenv} em qualquer parte do texto. %
Isso permite tirar d\'uvidas sobre a sua utiliza\cao\ sem sair do documento.%

\@helpTxtEnvironments%
\end{@textoNotaExpl}%
}%
\newcommand{\helpEnvironments}[1][]{\notasExplicativasEnvironments[#1]}%

\newcommand{\notasExplicativasEstruturaRelatorio}[1][]{%
\begin{@textoNotaExpl}{#1}%
Este texto \'e exemplo da estrutura de um Relat\'orio de F\ii sica Experimental.\\ %
Esta estrutura deve ser usada mesmo se decidir escrever o seu rela\-t\'orio com outra aplica\cao. Pode alterar os nomes das Sec\coes\ aqui sugeridas, mas a estrutura deve ser mantida:%
\vspace*{-3mm} %
\begin{enumerate}%
\itemsep -1mm %
\item Resumo%
\item Objetivos do Trabalho%
\item Procedimentos Experimentais%
    \vspace*{-2mm} %
	\begin{enumerate}[label*=\arabic*.]%
	\item Medi\coes\ e Dados Obtidos%
	\end{enumerate}%
\item An\'alise de Resultados%
\item Discuss\ao\ e Conclus\oes%
\item Refer\^encias%
\end{enumerate}%
\vspace*{-2mm} %
Deve tamb\'em incluir as Subsec\coes\ e Subsubsec\coes\ que achar necess\'arias para aumentar a legibilidade e compreens\ao\ do seu relat\'orio.%
\end{@textoNotaExpl}%
}%

\newcommand{\notasExplicativasLaTeX}[1][]{%
\begin{@textoNotaExpl}[]{#1} %
O objetivo deste documento \'e demonstrar a utiliza\cao\ do \LaTeX\ em v\'arias situa\coes\ de texto cient\ii fico, como algumas das suas capacidades de formata\cao.%

H\'a muita informa\cao\ na web sobre a utiliza\cao\ do \LaTeX\ e aconselha-se a sua consulta. O melhor reposit\'orio de informa\cao\ est\'a em \href{http://pt.wikibooks.org/wiki/Latex}{\sffamily pt.wikibooks.org\slash wiki\slash Latex} e \textit{recomenda-se a sua utiliza\cao}.\par%
\noindent\textbf{\textsc{Pronuncia\cao}}: a \'ultima letra no nome \LaTeX\ \'e um $\chi$ (\textit{qui}) grego mai\'usculo, da\ii\ \uline{pronunciar-se \textit{lateq}}.%

O \LaTeX\ n\ao\ \'e um processador de texto "\textsf{wysiwyg}"\ (iniciais de "\textit{what you see is what you get}"\ $=$ "\textit{o formato que v\^e no ecr\~a \'e como fica impresso}"), mas \'e uma linguagem de formata\cao\ de texto. Em \LaTeX\ escreve-se numa file de texto simples (\texttt{file.txt}), que cont\'em o texto pretendido a ficar impresso, mas tamb\'em os comandos que o formatam para produzir a vers\ao\ a imprimir (pdf). Para entender melhor, compare as vers\oes\ desta file em \texttt{.tex} e \texttt{.pdf}. %
A formata\cao\ (estilo) de base \'e inclu\ii da na primeira linha, com o comando %
\@macroName[Btt]{documentclass}{[11pt]}{\{classe\}}. %
H\'a \texttt{classes} pr\'e definidas: \texttt{article}, \texttt{book}, \texttt{report}, \texttt{letter}. etc. %
Elas definem o tipo de divi\soes\ poss\ii veis: \texttt{part}, \texttt{chapter}, \texttt{section}, \texttt{subsection}, \texttt{subsubsection}, \texttt{tableofcontents}, \texttt{thebibliography}, etc.. Ainda se pode redefinir o tamanho do papel, margens, etc., para al\'em das pr\'e-defini\coes\ que existem.%

\textbf{Procedimento para compilar o seu \LaTeX}: \vspace*{-2mm}%
\begin{enumerate}[font=\bf,label=\arabic*)]%
\itemsep -0.8mm%
\item Escrever o texto numa "\texttt{file.tex}"\ que n\ao\ fica formatada em "wysiwyg". %
\item Compila-se a file com o comando: "\texttt{pdflatex file.tex}", ou clica no \ii cone respetivo, ou usa a tecla 'F1' ({\sffamily Texmaker}), que gera a file formatada "\texttt{file.pdf}". %
\item As refer\^encias a n\'umeros de p\'agina, figuras, equa\coes, tabelas e bibliografia, s\'o ficam com a numera\cao\ correta depois de compilar a sua file 2 (ou 3) vezes seguidas.%
\end{enumerate}%

Para facilitar o trabalho est\ao\ dispon\ii veis (gratuitamente) muitos programas que fazem a edi\cao\ do texto e a inclus\ao\ simplificada dos comandos \LaTeX, fazendo realce colorido destes e de estruturas. Para Apple macOS \textit{recomenda-se} o \href{http://www.xm1math.net/texmaker/download.html}{\sffamily Texmaker} que tamb\'em tem \'optimas vers\oes\ para Linux e MS-Windows. O {\sffamily Texmaker} necessita do compilador \href{http://tug.org/mactex/}{\sffamily MacTex} que \'e muito bom. Para MS-Windows tem o editor %
\href{http://www.texniccenter.org}{\sffamily TeXnicCenter} que usa o compilador %
\href{http://www.miktex.org}{\sffamily MikTeX} ou o %
\href{http://www.tug.org/texlive/}{\sffamily TexLive}, que tem vers\oes\ para outras plataformas. %

Para quem se habituou a escrever no processador de texto {\sffamily MSWord}, h\'a conversores de documentos como o \href{http://www.wordtolatex.com}{\sffamily Word-to-LaTeX} que permitem exportar files \texttt{fl.doc} para formato \LaTeX\ de um modo apenas aceit\'avel. Depois disso, \textit{\'e preciso rearranjar o seu texto na} \texttt{file.tex}, introduzindo-o nas sec\coes\ respetivas, ajustar os comandos de inclus\ao\ de imagens, as estruturas de tabelas e listas. Nestes relat\'orios a primeira linha \uline{\textit{deve obrigatoriamente}} indicar: \@macroName[Btt]{documentclass}{[11pt]}{\{\@myClassName\}}.%
\end{@textoNotaExpl}%
}%

\newcommand{\notasExplicativasObjectivosTrabalho}[1][]{%
\begin{@textoNotaExpl}{#1}%
Apresente uma descri\cao\ sucinta dos objetivos cient\ii ficos do trabalho: que leis f\ii sicas se pretendem estudar e que m\'etodos se pretendem usar e/ou estudar se for esse o caso.%
Devem real\ca r-se alguns dos aspetos te\'oricos que sejam mais relevantes para o relat\'orio. Note-se que em geral est\ao\ todos descritos no protocolo e, por isso, reduza \`as leis e equa\coes\ que ser\ao\ usadas na an\'alise de resultados, mas deve ajuizar da sua extens\ao.%
\end{@textoNotaExpl}%
}%

\newcommand{\notasExplicativasProcedimentosExperimentais}[1][]{%
\begin{@textoNotaExpl}{#1}%
Como o detalhe dos procedimentos est\'a no protocolo, deve apenas incluir uma \textit{breve} descri\cao\ dos mesmos. Por\'em, dever\'a elaborar mais as situa\coes\ em que os procedimentos efetuados n\ao\ seguiram o protocolo, ou se h\'a raz\oes\ para explicitar melhor o que realizou.%
\end{@textoNotaExpl}}%

\newcommand{\notasExplicativasAspectosTeoricos}[1][]{%
\begin{@textoNotaExpl}{#1}%
Devem aqui real\ca r-se alguns dos aspetos te\'oricos que sejam mais relevantes para o relat\'orio. Note-se que em geral est\ao\ todos descritos no protocolo e, por isso, reduza \`as leis e equa\coes\ que ser\ao\ usadas na an\'alise de resultados, mas deve ajuizar da sua extens\ao.%
\end{@textoNotaExpl}}%

\newcommand{\notasExplicativasMedicoesDadosObtidos}[1][]{%
\begin{@textoNotaExpl}{#1}%
O ideal ser\'a incluir todos os dados experimentais obtidos mas isso \'e muitas vezes impratic\'avel, e noutras vezes nem \'e desej\'avel. Al\'em disso demora-se algum tempo a copiar as tabelas de todos os dados obtidos para o texto, devido \`a sua quantidade. Dependendo da situa\cao, devem ou podem ser apenas inclu\ii dos:%
\vspace*{-3mm}%
\begin{itemize}%
\itemsep -1mm  %
\item Um resumo com os mais significativos.%
\item Agrafar fotoc\'opias do caderno, como anexo.%
\item Agrafar a lista impressa dos mesmos, como anexo.%
\item Coloc\'a-los online para se poderem consultar, inclu\ii ndo o endere\c {\tt url}\cite{nossosdados} nas refer\^encias.%
\end{itemize}%
\end{@textoNotaExpl}%
\vspace*{-3mm}%
}%

\newcommand{\notasExplicativasAnaliseResultados}[1][]{%
\begin{@textoNotaExpl}{#1}%
Os resultados s\ao\ produzidos recorrendo a tabelas e an\'alise estat\ii stica dos valores medidos, aos par\^ametros de ajuste aos dados  e visualizados em gr\'aficos, e finalmente usados nas equa\coes\ f\ii sicas adequadas. Deve-se depois discutir em detalhe os resultados que se deduzem dos valores obtidos:%
\vspace*{-1.5mm}%
\begin{itemize}%
\itemsep -0.5mm%
\item Ao deduzir o mesmo par\^ametro por duas vias, compar\'a-los e discutir qual deles \'e melhor.%
\item Comparar os valores obtidos com os valores esperados, se for caso disso.%
\item Discutir a raz\ao\ que fundamenta desvios sistem\'aticos nos resultados obtidos, se existirem. %
\end{itemize}%
\end{@textoNotaExpl}%
}%

\newcommand{\notasExplicativasResultadosConclusoes}[1][]{%
\begin{@textoNotaExpl}{#1}%
Baseando-se nos resultados deduzidos dos valores experimentais, devem-se discutir as implica\coes\ cient\ii ficas dos mesmos, ou seja, a confirma\cao\ da lei f\ii sica em causa, o grau de incerteza nessa conclus\ao, o que se poderia fazer para melhorar os resultados tanto na metodologia experimental como no tratamento de dados realizado.%
\end{@textoNotaExpl}%
}%

\newcommand{\@pdftitulo}{}%
\newcommand{\pdftitle}[1]{\renewcommand{\@pdftitulo}{#1}}%
\@appendHelpOutrsCmdsPreamb{pdftitle}{\{t\ii tulo do relat\'orio\}}{ Para criar um t\ii tulo diferente nas propriedades do documento \texttt{.pdf}. \uline{\textit{\'E opcional}} pois \'e criado automaticamente com o t\ii tulo do seu relat\'orio. Contudo, se esse t\ii tulo tiver comandos LaTeX pelo meio, eles ser\ao\ mostrados tal e qual (sem expans\ao). Este comando permite redefinir esta string a\-de\-quadamente.%
}%

\newcommand{\@pdfautor}{}%
\newcommand{\pdfauthor}[1]{\renewcommand{\@pdfautor}{#1}}%
\@appendHelpOutrsCmdsPreamb{pdfauthor}{\{autorA,autorB,autorC\}}{ Para alterar os nomes dos autores nas propriedades do documento \texttt{.pdf}. \uline{\textit{\'E opcional}} pois \'e criado automaticamente como aqui apresentado. Por\'em, se o nomes no documento tiverem comandos LaTeX pelo meio eles ser\ao\ mostrados tal e qual (sem expans\ao). Este comando permite redefinir esta string adequadamente.}%

\newcommand{\@pdfassunto}{}%
\newcommand{\pdfsubject}[1]{\renewcommand{\@pdfassunto}{#1}}%
\@appendHelpOutrsCmdsPreamb{pdfsubject}{\{texto do assunto\}}{ Para alterar a string do  \texttt{assunto} nas propriedades do documento \texttt{.pdf}. \uline{\textit{\'E opcional}} mas \'e criado automaticamente sempre com o mesmo conte\'udo: \\ %
\texttt{Relat\'orio de 'NomeDoCurso', ano, FCUL}. O comando permite redefinir esta string.}%

\newcommand{\@pdfkeyword}{}%
\newcommand{\pdfkeywords}[1]{\renewcommand{\@pdfkeyword}{#1}}%
\@appendHelpOutrsCmdsPreamb{pdfkeywords}{\{\{palavras\},\{chave\}\}}{ Para criar palavras-chave nas propriedades do documento \texttt{.pdf}. \uline{\textit{\'E opcional}} mas \'e criado sempre com o mesmo conte\'udo: \texttt{\{\{An\'alise de dados\}, \{F\ii sica Experimental\},\{estat\ii stica\}\}}. O comando permite redefinir as strings adequadamente.}%

\newcommand{\http}[2][]{%
\StrSubstitute[0]{#2}{/}{\slash }[\@urlSslashs]%
\ifthenelse{\equal{#1}{}}%
 {\href{http://#2}{\small\sffamily http://\hspace*{-0.1mm}/\@urlSslashs}}%
 {\href{http://#2}{#1\sffamily http://\hspace*{-0.1mm}/\@urlSslashs}}%
}%
\newcommand{\https}[2][]{%
\StrSubstitute[0]{#2}{/}{\slash }[\@urlSslashs]%
\ifthenelse{\equal{#1}{}}%
 {\href{https://#2}{\small\sffamily https:/\hspace*{-0.1mm}/\@urlSslashs}}%
 {\href{https://#2}{#1\sffamily https:/\hspace*{-0.1mm}/\@urlSslashs}}%
}%
\@appendToHelpCmd[http]{[sz]\{url\}}{URL}{ Para referenciar um endere\co\ \texttt{url}. O texto \texttt{url} deve omitir a parte \texttt{http://}. Se \texttt{[sz]} for omisso ou vazio [] o texto fica no tamanho pequeno \texttt{$\backslash$small}. Sen\ao, usa o que l\'a estiver: ex.\ \@macroName[Btt]{http}{[\@macroName{footnotesize}{}{.}]}{\{url\}}. O \texttt{url} aparece em fonte n\ao\ serifada. }{Opcionais}%
\@appendToHelpCmd[https]{[sz]\{url\}}{URLs}{ Para referenciar um endere\co\ \texttt{url} seguro. O texto \texttt{url} deve omitir a parte \texttt{https://}. Se \texttt{[sz]} for omisso ou vazio [] o texto fica no tamanho pequeno \texttt{$\backslash$small}. Sen\ao, usa o que l\'a estiver: ex.\ \@macroName[Btt]{https}{[\@macroName{normalsize}{}{.}]}{\{url\}}. O \texttt{url} fica em fonte n\ao\ serifada.}%
{Opcionais}%

\providecommand{\sectionprg}[2][]{%
 \ifthenelse{\equal{#1}{}}%
   {\section{#2}} %
   {\section[#1]{#2}}%
 \setcounter{lstlisting}{0}%
 \renewcommand{\thelstlisting}{P\thesection-\arabic{lstlisting}}%
}%

\providecommand{\subsectionprg}[2][]{%
 \ifthenelse{\equal{#1}{}}%
   {\subsection{#2}} %
   {\subsection[#1]{#2}}%
 \setcounter{lstlisting}{0}%
 \renewcommand{\thelstlisting}{P\thesubsection-\arabic{lstlisting}}%
}%

\@appendToHelpCmd[sectionprg]{[shortName]\{section name\}}{Sec\cao\ com c\'odigo de programa\cao}{ Inicia uma sec\cao\ que pode conter quadros com c\'odigo numa linguagem de programa\cao\ e os referencia \`a numera\cao\ da sec\cao. %
Os programas s\ao\ numerados por \texttt{P\#sec-\#prog}, em vez de um n\'umero corrido em todo o documento. %
Os quadros s\ao\ uma caixa colorida em que h\'a realce apropriado dos comandos e estruturas da linguagem de programa\cao, com as linhas numeradas. %
Usa a package \texttt{listings}.}{Opcionais}%

\@appendToHelpCmd[subsectionprg]{[shortName]\{sub\-sec\-tion name\}}{Subsec\cao\ com c\'odigo de programa\cao}{ Inicia uma subsec\cao\ que pode conter quadros com c\'odigo numa linguagem de progra\-ma\cao\ e os referencia \`a numera\cao\ da subsec\cao, do tipo %
\texttt{P\#sec.\#subsec-\#prog}, em vez de um n\'umero corrido em todo o documento. %
Os quadros s\ao\ uma caixa colorida em que h\'a realce apropriado dos comandos e estruturas da linguagem de programa\cao, com as linhas numeradas. %
Usa a package \texttt{listings}.}{Opcionais}%

\providecommand{\eq}{\ensuremath{\!=\!}}%
\providecommand{\m}{\ensuremath{\!-\!}}%
\@appendToHelpCmd[eq]{ \textbackslash m}{Sinais com espa\co s curtos}{. Estes sinais deixam menos espa\co\ de separa\cao\ \`a sua esquerda e direita e por vezes podem ser \'uteis. 1- O sinal de igual: x\textbackslash\texttt{eq} y = 'x\eq y', em vez do habitual $x=y$; %
2- O sinal de subtra\cao: x\textbackslash\texttt{m} y = 'x\m y', em vez do habitual $x-y$. Podem ser usados no texto em linha, assim como dentro do modo matem\'atico. }%
{Matematicos}%

\newcommand{\smallSizeMath}[1]%
  {\protect{\begingroup\everymath{\scriptstyle}\ensuremath{#1}\endgroup}}%

\providecommand{\UpScript}[1]{\textsuperscript{\underline{#1}}}%
\providecommand{\upo}{\UpScript{o}}%
\providecommand{\upa}{\UpScript{a}}%

\@appendToHelpAbreviaturas[1]{upo}%
\@appendToHelpAbreviaturas[1]{upa}%

\providecommand{\etal}{\textit{et al.\xspace}}%
\providecommand{\ie}{i.\ e.\xspace}%

\@appendToHelpAbreviaturas{etal}%
\@appendToHelpAbreviaturas{ie}%

\providecommand{\eg}{e.\ g.\xspace}%
\providecommand{\etc}{etc.\xspace}%

\@appendToHelpAbreviaturas{eg}%
\@appendToHelpAbreviaturas{etc}%

\providecommand{\st}{\ensuremath{^{st}}}%
\renewcommand{\st}{\ensuremath{^{st}}\xspace}%
\providecommand{\nd}{\ensuremath{^{nd}}}%
\renewcommand{\nd}{\ensuremath{^{nd}}\xspace}%
\providecommand{\rd}{\ensuremath{^{rd}}}%
\renewcommand{\rd}{\ensuremath{^{rd}}\xspace}%
\providecommand{\th}{\ensuremath{^{th}}}%
\renewcommand{\th}{\ensuremath{^{th}}\xspace}%
\providecommand{\uth}{\ensuremath{^{th}}\xspace}%

\@appendToHelpAbreviaturas[1]{st}%
\@appendToHelpAbreviaturas[2]{nd}%
\@appendToHelpAbreviaturas[3]{rd}%
\@appendToHelpAbreviaturas[4]{th}%

\newcommand{\kohm}{\ensuremath{\mathrm{k\Omega}}\xspace}%
\newcommand{\Mohm}{\ensuremath{\mathrm{M\Omega}}\xspace}%
\newcommand{\ohm}{\ensuremath{\mathrm{\Omega}}\xspace}%
\newcommand{\mA}{\ensuremath{\mathrm{mA}}\xspace}%
\newcommand{\A}{\ensuremath{\mathrm{\ A}}\xspace}%
\newcommand{\uA}{\ensuremath{\mu \mathrm{A}}\xspace}%
\newcommand{\us}{\ensuremath{\mu \mathrm{s}}\xspace}%

\@appendToHelpCmd[unidade]{.}{Resist\^encia e Corrente el\'etrica}{ Existem abreviaturas '\texttt{unidade}' de m\'ultiplos e sub-m\'ultiplos de unidades que podem ser usados no texto em linha, assim como dentro do modo matem\'atico. Os comandos dispon\ii veis s\ao\ os seguintes: %
\textbackslash\texttt{kohm} = \kohm\ ; \textbackslash\texttt{Mohm} = \Mohm\ ; %
\textbackslash\texttt{ohm} = \ohm\ ; \textbackslash\texttt{mA} = \mA\ ; %
\textbackslash\texttt{A} = \A\ ; \textbackslash\texttt{uA} = \uA\ ; %
\textbackslash\texttt{us} = \us. %
\textbf{NOTA:} estes comandos usados sem um \textbackslash\ final \textit{n\ao\ se colam \`a letra} que vier a seguir: \@macroName{kohm}{}{.} $\beta\rightarrow$ \kohm $\beta =$ \@macroName{kohm}{\textbackslash}{.}\textvisiblespace$\beta$. %
Mas se estiver uma pontua\cao\ logo a seguir, eles colam-se \`a marca: \@macroName{kohm}{}{.} ; $\rightarrow$ \kohm ; %
}{Opcionais}%

\providecommand{\Exp}[3][]{\ensuremath{#2%
   \ifthenelse{\equal{#3}{}}{}%
   {\begingroup\everymath{\scriptstyle}\!\times\!\endgroup}10^{#3}%
    \ifthenelse{\equal{#1}{}}{}{\>\mathrm{#1}}}%
}%

\@appendToHelpCmd[Exp]{[u]\{m\}\{e\}}{Nota\cao\ cient\ii fica com unidades}{ onde \texttt{m}=mantissa, \texttt{e}=expoente e unidades \texttt{u} que s\ao\ opcionais. %
Estes par\^ametros s\ao\ processados dentro do ambiente matem\'atico $\Rightarrow$ podem ser f\'ormulas que n\ao\ precisam de ser encapsuladas em \$ \$ ou $\backslash[$ $\backslash]$, mas dentro deles tamb\'em funcionam. Exemplos:  \@macroName{Exp}{\{12\}\{24\}}{.}=\Exp{12}{24}\quad mas \@macroName{Exp}{[kg/m\^{}2]\{12\}\{24\}}{.}=\Exp[kg/m^2]{12}{24}.}%
{Matematicos}%

\providecommand{\dg}{\ensuremath{^\circ}}%

\@appendToHelpCmd[dg]{.}{S\ii mbolo de grau}{ Este comando introduz o s\ii mbolo de grau. \'E processado dentro do ambiente matem\'atico $\Rightarrow$ n\ao\ precisa de ser encapsulado em \$ \$ ou $\backslash[$ $\backslash]$, mas dentro deles tamb\'em funciona. Exemplos: o texto "5\@macroName{dg}{}{.}" = 5\dg\quad e a f\'ormula \$ 5\@macroName{dg}{}{.}\$ => $5\dg$.}%
{Matematicos}%

\newcommand{\equ}[2][]{\begin{equation}{#2}%
                         \ifthenelse{\equal{#1}{}}%
                         {}%
                         {\label{#1}}%
                        \end{equation}%
}%
\@appendToHelpCmd[equ]{[eq:lbl]\{equa\cao\}}{Equa\cao\ em DisplayMode}{ A \texttt{equa\cao} fica numerada \`a direita. \'E processada dentro do ambiente matem\'atico $\Rightarrow$ n\ao\ precisa de ser encapsulada em \$ \$ ou $\backslash[\ \backslash]$, mas dentro deles tamb\'em funciona. O \texttt{eq:lbl} \'e opcional mas se for usado passa a referenciar \uline{a equa\cao}. Este formato permite que a macro \@macroName{referir}{\{eq:lbl\}}{.} ponha a refer\^encia como \textit{equa\cao\ (nn) (p\'ag.\ pp)}. %
Exemplo: \@macroName{equ}{\{$\backslash$frac\{m\}\{s\} $\backslash$sin(-$\backslash$omega\ t+$\backslash$varphi)\}}{.} escreve%
\equ{\frac{m}{s} \sin(-\omega t+\varphi)}\par\vspace*{-3mm}%
}{Matematicos}%

\newcommand{\fequ}[2][]{%
  \begin{equation}%
   \fbox{\ensuremath{\displaystyle #2}}%
   \ifthenelse{\equal{#1}{}}{}%
     {\label{#1}}%
  \end{equation}%
}%
\@appendToHelpCmd[fequ]{[eq:lbl]\{equa\cao\}}{Equa\cao\ em destaque com caixa}{ Para criar uma equa\cao\ emoldurada e separada dos par\'agrafos. A \texttt{equa\cao} \'e processada dentro do ambiente matem\'atico DisplayMode $\Rightarrow$ N\AO\ deve ser encapsulada em \$ \$ nem $\backslash[\ \backslash]$. O \texttt{eq:lbl} \'e opcional mas se for usado passa a referenciar esta equa\cao. Este formato permite que a macro \@macroName{referir}{\{eq:lbl\}}{.} ponha a refer\^encia como \textit{equa\cao\ (nn) (p\'ag.\ pp)}. Exemplo:%
\fequ{\frac{m}{s} \sin(-\omega t+\varphi)}\par\vspace*{-3mm}}%
{Matematicos}%

\newcommand{\fmath}[2][]{%
 \fbox{\ensuremath{\textstyle #2}}%
 \ifthenelse{\equal{#1}{}}{}%
   {\label{#1}}%
}%
\@appendToHelpCmd[fmath]{[seq:lbl]\{equa\cao\}}{Equa\cao\ na linha com caixa}{ Para criar uma equa\cao\ emoldurada mas que fica na linha de texto. O c\'odigo \texttt{equa\cao} \'e processado dentro do ambiente matem\'atico $\Rightarrow$ n\ao\ precisa de ser encapsulada em \$ \$ ou \texttt{\textbackslash[\ \textbackslash]}, %
mas dentro deles tamb\'em funciona. O \texttt{seq:lbl} \'e opcional mas se usado \uwave{passa a referenciar a sec\cao\ da equa\cao}, pois ela n\ao\ \'e numerada (individualizada). Este formato permite que a macro \@macroName{referir}{[.]\{seq:lbl\}}{.} ponha a refer\^encia como \textit{sec.\ nn (p\'ag.\ pp)}. %
Ex: \fmath{\frac{m}{s} \sin(-\omega t+\varphi)}.\\ %
}{Matematicos}%

\newenvironment{eqmult}%
  {\vspace*{-2mm}\begin{eqnarray*}}%
  {\end{eqnarray*} \vspace*{-0mm}}%
  
\@appendToHelpEnvironments{Equa\coes\ M\'ultiplas}{eqmult}{}%
{leq \& = \& req\ }{Para criar uma matriz de equa\coes\ (equation array) com lado esquerdo \texttt{leq}, sinal de $=$ ao centro e equa\coes\ \texttt{req} \`a direita, separadas pelo caracter \&.}%

\newcommand{\@figTxt}[1][]{%
 \IfBeginWith{#1}{.}%
 {fig.}%
 {\ifthenelse{\boolean{@ingles}}%
   {figure}{figura}%
 }\ %
}%

\newcommand{\@tabTxt}[1][]{%
 \IfBeginWith{#1}{.}%
 {tab.}%
 {\ifthenelse{\boolean{@ingles}}%
   {table}{tabela}%
 }\ %
}%

\newcommand{\@eqTxt}[1][]{%
 \IfBeginWith{#1}{.}%
 {eq.}%
 {\ifthenelse{\boolean{@ingles}}%
   {equation}{equa\cao}%
 }\ %
}%

\newcommand{\@secTxt}[1][]{%
 \IfBeginWith{#1}{.}%
 {sec.}%
 {\ifthenelse{\boolean{@ingles}}%
   {section}{sec\cao}%
 }\ %
 }%

\newcommand{\@apdTxt}{%
 \ifthenelse{\boolean{@ingles}}%
   {appendix}{ap\^endice}\ %
}%

\newcommand{\@prgTxt}[1][]{%
 \IfBeginWith{#1}{.}%
 {prg.}%
 {\ifthenelse{\boolean{@ingles}}%
   {program}{programa}\ %
}}%

\newcommand{\@cmdTxt}[1][]{%
 \IfBeginWith{#1}{.}%
 {cmd.}%
 {\ifthenelse{\boolean{@ingles}}%
   {command}{comando}%
 }\ %
 }%

\newcommand{\@nxtpg}{%
 \ifthenelse{\boolean{@ingles}}%
   {next page}{p\'{a}g.\ seguinte}%
}%
\newcommand{\@prvpg}{%
 \ifthenelse{\boolean{@ingles}}%
   {previous page}{p\'{a}g.\ anterior}%
}%

\newcommand{\@pgTxt}{%
 \ifthenelse{\boolean{@ingles}}%
   {page}{p\'{a}g.}%
}%

\newcommand{\@paginaTxt}{%
 \ifthenelse{\boolean{@ingles}}%
   {page}{p\'{a}gina}\ %
}%

\newcommand{\@onpgTxt}{%
 \ifthenelse{\boolean{@ingles}}%
   {on}{na}%
}%

\newcommand{\@refpagina}{0}%
\newcommand{\@setProxPagina}[1]{\renewcommand{\@refpagina}{#1}}%
\newcommand{\@tipoFloat}{0}%
\newcounter{@pgdif}%

\newboolean{boolP}%
\newboolean{boolSEC}%
\newboolean{boolSEQ}%
\newboolean{boolSC}%
\newboolean{boolG}%

\newcommand{\@testTXT}[3][boolSEC]{%
\IfSubStr{#3}{#2}{\setboolean{#1}{true}}{\setboolean{#1}{false}}}%

\newcommand{\@testLastLtrs}[3][boolG]{%
\IfEndWith{#3}{#2}{\setboolean{#1}{true}}{\setboolean{#1}{false}}}%

\newcommand{\@nomeFloatNoLbl}[2][]{%
\StrBefore[1]{#2}{:}[\@tipoFloat]%
\IfStrEq{\@tipoFloat}{eq}%
{\@eqTxt[#1]}%
{\IfStrEq{\@tipoFloat}{fig}%
 {\@figTxt[#1]}%
 {\@testTXT[boolSEC]{sec}{\@tipoFloat}%
  \@testTXT[boolSEQ]{seq}{\@tipoFloat}%
  \@testTXT[boolSC]{sc}{\@tipoFloat}%
  \ifthenelse{\boolean{boolSEC} \OR \boolean{boolSEQ} \OR \boolean{boolSC}}%
  {\@secTxt[#1]}%
  {\IfStrEq{\@tipoFloat}{tab}%
   {\@tabTxt[#1]}%
   {\IfStrEq{\@tipoFloat}{item}%
    {item\ }%
    {\IfSubStr{\@tipoFloat}{ap}%
     {\@apdTxt}%
     {\IfSubStr{\@tipoFloat}{cmd}%
      {\@cmdTxt}%
      {\@testTXT[boolP]{p}{\@tipoFloat}%
       \@testLastLtrs[boolG]{g}{\@tipoFloat}%
       \ifthenelse{\boolean{boolP} \AND \boolean{boolG}}%
       {\@prgTxt[#1]}%
       {}%
      }%
     }%
    }%
   }%
  }%
 }%
}%
}%

\newcommand{\@opcUmRefrr}{(}%

\newcommand{\referir}[2][(]{%
 \setcounter{@pgdif}{\number\numexpr\getpagerefnumber{#2}-\value{page}}%
 \@nomeFloatNoLbl[#1]{#2}%
 \renewcommand{\@opcUmRefrr}{#1}%
 \ifthenelse{\equal{\ref{#2}}{}}%
  {---n\ao\ funciona no $\backslash$referir---}%
  {\ifthenelse{\equal{\@tipoFloat}{eq} \OR \equal{\@tipoFloat}{cmd}}%
    {(\ref{#2})}%
    {\ref{#2}}%
   \IfSubStr{\@opcUmRefrr}{.}%
    {\StrDel[1]{\@opcUmRefrr}{.}[\@opcUmRefrr]}{}%
   \IfSubStr{\@opcUmRefrr}{,}%
    {,%
     \StrDel[1]{\@opcUmRefrr}{,}[\@opcUmRefrr]}{}%
  }%
 \ifthenelse{\value{@pgdif}=0}%
  {\@setProxPagina{}}%
  {%
   \ifthenelse{\value{@pgdif}=1}%
     {\@setProxPagina{\@nxtpg}}%
     {\ifthenelse{\value{@pgdif}=-1}%
       {\@setProxPagina{\@prvpg}}%
       {\@setProxPagina{\@pgTxt\ \pageref{#2}}}%
     }%
   \IfSubStr{\@opcUmRefrr}{(}%
    { (\@refpagina)}%
    {\ifthenelse{\equal{\@opcUmRefrr}{} \OR \equal{\@opcUmRefrr}{ }}%
       { \@onpgTxt\ \@refpagina}%
       { \@opcUmRefrr\ \@refpagina}%
    }%
  }%
}%

\@appendToHelpCmd[referir]{[aa]\{float:lbl\}}{Refer\^encias Inteligentes}{ %
Para fazer refer\^encias inteligentes ao \texttt{float} de etiqueta \texttt{lbl} e \`a p\'agina deste. O texto produzido \'e do tipo \textit{floatName XX (p\'ag.\ nn)}. \vspace*{-3.5mm}%
\begin{itemize}%
\itemsep -1mm%
 \item Os labels usados na identifica\cao\ do \texttt{float} \textbf{t\^em de ser} do tipo \texttt{fig:xxx}  ou \texttt{tab:xxx} ou \texttt{eq:xxx} ou \texttt{seq:xxx} ou \texttt{sc/sec:xxx} ou \texttt{item:xxx} ou \texttt{sapp/app:xxx} ou \texttt{pg/prg:xxx} pois a string antes de ':' \'e usada na frase de refer\^encia, que ficar\'a: 'figura XX'  ou 'tabela XX' ou 'equa\cao\ XX' ou 'sec\cao\ XX' ou 'item XX' ou 'ap\^endice XX' ou 'programa XX'  sempre seguida de ' (p\'ag. nn)' como default.\\ %
As op\coes\ indicadas como \texttt{aa/bbb} permitem as duas variantes \texttt{aa:xxx} ou \texttt{bbb:xxx}.\\ %
A frase final pode ser alterada de v\'arias maneiras:%
\begin{enumerate}%
\itemsep -0mm%
\item Para evitar os par\^enteses na refer\^encia \`a p\'agina, caso de \textit{tabela XX na p\'ag.\ nn},  use a op\cao\ vazia []:\\ \@macroName{referir}{[]\{tab:xxx\}}{.}%
\item Para colocar um texto 'aaa' antes de 'p\'ag. nn' e sem os par\^enteses, caso de \textit{figura XX aaa p\'ag.\ nn}, use a op\cao\ [aaa]: %
  \@macroName{referir}{[aaa]\{fig:xxx\}}{.}  %
\item Para ter uma designa\cao\ abreviada do tipo 'prg.', 'eq.', 'sec.', 'fig.', 'tab.' e sem par\^enteses, use a op\cao\ com um ponto [.]: %
\@macroName{referir}{[.]\{sec:xxx\}}{.} => \textit{sec.\ XX na p\'ag.\ nn}. %
\item Usar a designa\cao\ abreviada mas mantendo os par\^enteses na refer\^encia \`a p\'agina, caso de \textit{sec.\ XX (p\'ag.\ nn)}, use a op\cao\ [.(]: %
\@macroName{referir}{[.(]\{sec:xxx\}}{.}%
\item Para separar o n\'umero do float da refer\^encia \`a p\'agina\ com uma v\ii rgula, use a op\cao\ [,]:\\ %
\@macroName{referir}{[,]\{eq:xxx\}}{.} => \textit{equa\cao\ (XX), na p\'ag.\ nn} (=> sem par\^enteses). %
\item As diversas op\coes\ podem ser juntas para ter o efeito combinado: ponto (.) e v\ii rgula (,) devem ser sempre primeiro e nessa ordem:\vspace*{-1mm}%
 \begin{itemize}%
 \itemsep -0mm%
 \item \@macroName{referir}{[.(]\{fig:xxx\}}{.} => \textit{fig.\ XX (p\'ag.\ nn)}%
 \item \@macroName{referir}{[.,]\{eq:xxx\}}{.} => \textit{eq.\ (XX), na p\'ag.\ nn}%
 \item \@macroName{referir}{[.j\'a na]\{tab:xxx\}}{.} => \textit{tab.\ XX j\'a na p\'ag.\ nn}\quad (fica sem par\^enteses).%
 \item \@macroName{referir}{[.,j\'a na]\{tab:xxx\}}{.} => \textit{tab.\ XX, j\'a na p\'ag.\ nn}\quad (fica sem par\^enteses).%
 \end{itemize}%
\end{enumerate}%
\item ATEN\CAO: as refer\^encias do tipo '\textit{anterior}' e '\textit{seguinte}' NEM sempre ficam corretas. Nesse caso use apenas \@macroName{ref}{\{lbl\}}{.} e refa\ca\ o texto para construir a refer\^encia como achar bem.%
\end{itemize}%
\vspace*{-3mm}%
}{Referir}%

\newcommand{\referiritemseccao}[3][(]{%
\@nomeFloatNoLbl[#1]{#2}\ref{#2} %
\referir[#1]{#3}%
}%
\@appendToHelpCmd[referiritemseccao]{[aa]\{sc/sec:lbl\}\{item:lbl\}}{ Refer\^encia a item de sec\cao}%
{\ se quiser fazer refer\^encias inteligentes ao \texttt{item} com \texttt{item:lbl} da \textit{sec\cao} com \texttt{sec:lbl} (ou \texttt{sc:lbl}) e \`a p\'agina deste. Este comando produz o texto \textit{sec\cao\ XX item YY (p\'ag.\ nn)}. Na realidade o comando equivale a: \texttt{sec\cao\ \textbackslash{ref}\{sec:lbl\} \textbackslash{referir[aaa]\{item:lbl\}}}. Por isso, as variantes da op\cao\ \texttt{aa} e do \texttt{sec:lbl} s\ao\ id\^enticas \`as do comando \@macroName{referir}{}{.}:%
\vspace*{-3mm}%
\begin{itemize}\itemsep -0mm%
 \item Os labels usados \textbf{t\^em de ser} do tipo \textsl{sec:xxx} e \textsl{item:xxx},  pois a string antes de ':' \'e usada para criar a frase '\textit{sec\cao\ XX item YY (p\'ag. nn)}', como default. Mas pode-se alterar de v\'arias maneiras:%
\begin{enumerate}%
\itemsep -0.mm%
\item Para evitar os par\^enteses na refer\^encia \`a p\'agina, caso de \textit{sec\cao\ XX item YY na p\'ag.\ nn}, use a op\cao\ vazia []: %
\@macroName{referiritemseccao}{[]\{sec:xxx\}\{item:lbl\}}{.}%
\item Colocar um texto 'aa' antes de 'p\'ag. nn' sem os par\^enteses: use a op\cao\ [aa]:\\ %
  \@macroName{referiritemseccao}{[aa]\{sec:xxx\}\{item:lbl\}}{.} => \textit{sec\cao\ XX item YY aa p\'ag.\ nn}%
\item Para ter a designa\cao\ abreviada 'sec.', \textit{sec.\ XX item YY na p\'ag.\ nn}, use a op\cao\ com um ponto [.]: %
\@macroName{referiritemseccao}{[.]\{sec:xxx\}\{item:lbl\}}{.}%
\item Para ter a designa\cao\ abreviada mas mantendo os par\^enteses na refer\^encia \`a p\'agina, caso de \textit{sec.\ XX item YY (p\'ag.\ nn)}, use a op\cao\ [.(]: \@macroName{referiritemseccao}{[.(]\{sec:xxx\}\{item:lbl\}}{.}%
\item Separar com uma v\ii rgula, o n\'umero do float da refer\^encia \`a p\'agina, caso de \textit{sec\cao\ XX item YY, na p\'ag.\ nn}, use a op\cao\ [,]: \@macroName{referiritemseccao}{[,]\{sec:xxx\}\{item:lbl\}}{.}%
\item Pode combinar as diversas op\coes\ mas o ponto (.) e v\ii rgula (,) devem estar sempre primeiro e nessa ordem:\vspace*{-1mm}%
 \begin{itemize}%
 \itemsep -0.mm%
 \item \@macroName{referiritemseccao}{[.,]\{sec:xxx\}\{item:lbl\}}{.} => \textit{sec.\ XX item YY, na p\'ag.\ nn}%
 \item \@macroName{referiritemseccao}{[.(]\{sec:xxx\}\{item:lbl\}}{.} => \textit{sec.\ XX item YY (p\'ag.\ nn)}%
 \item \@macroName{referiritemseccao}{[.j\'a na]\{sec:xxx\}\{item:lbl\}}{.}=> \textit{sec.\ XX item YY j\'a na p\'ag.\ nn} (fica sem par\^enteses). %
 \item \@macroName{referiritemseccao}{[.,j\'a na]\{sec:xxx\}\{item:lbl\}}{.}=> \textit{sec.\ XX item YY, j\'a na p\'ag.\ nn} (fica sem par\^enteses). %
\end{itemize}%

\end{enumerate}%
\item ATEN\CAO: as refer\^encias do tipo '\textit{anterior}' e '\textit{seguinte}' NEM sempre ficam corretas. Nesse caso use apenas \@macroName{ref}{\{lbl\}}{.} e refa\ca\ o texto para construir a refer\^encia como achar bem. %
\end{itemize}%
\vspace*{-3mm}%
}{Referir}%

\providecommand{\footref}[2][]%
  {\textsuperscript{\ref{#2}%
\ifthenelse{\equal{#1}{}}{}%
{ (pg~\pageref{#2})}%
}}%
\@appendToHelpCmd[footref]{[]\{lbl\}}{Refer\^encia a um footnote}{ Este comando p\~oe em expoente o n\'umero do footnote que tem a etiqueta \texttt{lbl}. Se quiser incluir o respetivo n\'umero da p\'agina, ent\~ao deve usar \@macroName{footref}{[p]\{lbl\}}{.}. Isto cria o texto \textsuperscript{xx (pg nn)}, onde \texttt{xx} \'e o n\'umero do footnote e \texttt{nn} o n\'umero da p\'agina onde \texttt{lbl} est\'a.}{Referir}%

\providecommand{\pag}[1]{\@pgTxt\ \pageref{#1}}%
\@appendToHelpCmd[pag]{\{lbl\}}{Refer\^encia \`a p\'agina}{ Este comando cria o texto abreviado \textit{p\'ag.\ XX} onde XX \'e o n\'umero da p\'agina onde est\'a o artigo com etiqueta \texttt{lbl}.}{Referir}%

\providecommand{\pagina}[1]{\@paginaTxt\ \pageref{#1}}%
\providecommand{\pagn}[1]{\@paginaTxt\ \pageref{#1}}%
\@appendToHelpCmd[pagn]{\{lbl\}}{Refer\^encia por extenso \`a p\'agina}{ ou %
\texttt{\textbackslash pagina\{lbl\}}. Este comando cria o texto \textit{p\'agina XX} onde XX \'e o n\'umero da p\'agina onde est\'a o artigo com etiqueta \texttt{lbl}.}%
{Referir}%

\newenvironment{lista}[1][]%
{\begin{itemize}[leftmargin=!,labelindent=-4mm,itemindent=0mm,align=right]%
  \setlength{\itemsep}{-0mm}%
  \setlength{\parskip}{7pt}%
  \IfStrEq{#1}{}{}{\label{#1}}%
}%
{\end{itemize}}%
\@appendToHelpEnvironments[lst:lbl]{Lista Indentada}{lista}{}{item : texto }{Para iniciar uma lista com a etiqueta dos itens indentada mais \`a esquerda e uma separa\cao\ extra entre eles. }%

\newcommand{\@itemMark}{}%

\newenvironment{listaNumRom}[1][]%
{\IfStrEq{#1}{}%
 {\renewcommand{\@itemMark}{\textit{\textbf{\roman*)}}}}%
 {\renewcommand{\@itemMark}{\textit{\textbf{\Roman*)}}}}%
\begin{enumerate}[leftmargin=!,labelindent=-4mm,itemindent=0mm,align=right,label=\@itemMark]%
  \setlength{\itemsep}{-0mm}%
  \setlength{\parskip}{7pt}%
}%
{\end{enumerate}}%
\@appendToHelpEnvironments[lst:lbl]{Lista numerada romana}{listaNumRom}{}{itemLista [item:lbl]\{txtIni\} texto }{ Para iniciar uma lista numerada em Romanos, com a etiqueta dos itens indentada mais \`a esquerda e uma separa\cao\ extra entre eles. A numera\cao\ \'e em min\'usculas mas pode ser em mai\'usculas usando o par\^ametro opcional [M]. }%

\newenvironment{listaNumAlf}[1][]%
{\IfStrEq{#1}{}%
 {\renewcommand{\@itemMark}{\textbf{\alph*)}}}%
 {\renewcommand{\@itemMark}{\textbf{\Alph*)}}}%
 \begin{enumerate}[leftmargin=!,labelindent=-4mm,itemindent=0mm,align=right,label=\@itemMark]%
  \setlength{\itemsep}{-0mm}%
  \setlength{\parskip}{7pt}%
}%
{\end{enumerate}}%
\@appendToHelpEnvironments[lst:lbl]{Lista numerada alfab\'etica}{listaNumAlf}{}{itemLista [item:lbl]\{txtIni\} texto}{Para iniciar uma lista numerada em Letras, com a etiqueta dos itens indentada mais \`a esquerda e uma separa\cao\ extra entre eles.  A numera\cao\ \'e em min\'usculas mas pode ser em mai\'usculas usando o par\^ametro opcional [M]. }%

\newcommand{\itemLista}[2][]{%
 \StrLen{#2}[\@Nboldtxt]%
 \ifthenelse{1 = \@Nboldtxt}%
  {\item #2}%
  {\item \textbf{#2}}%
 \IfStrEq{#1}{}{}{\label{#1}}%
}%
\@appendToHelpCmd[itemLista]{[item:lbl]\{txtIni\} Texto. }{item de Lista}{para iniciar um item duma lista descritiva mas com \texttt{item:lbl} para ser referenciado (\'e opcional). O texto fica: \textbf{txtIni} \texttt{Texto}. %
O formato permite que a macro \@macroName{referir}{\{item:lbl\}}{.} ponha a refer\^encia como \textit{item xx (p\'ag.\ pp)}, onde \textit{xx} assume a numera\cao\ da lista usada.%
}{Opcionais}%

\newcommand{\figura}[4][]{%
\noindent%
\begin{minipage}{\linewidth}%
 \makebox[\linewidth]{%
   \includegraphics[width=#2]{#3}}%
 \ifthenelse{\equal{#4}{}}{}%
   {\captionof{figure}{#4}}%
 \ifthenelse{\equal{#1}{}}{}%
   {\label{#1}}%
\end{minipage}%
}%

\newcommand{\tabela}[4][]{%
\noindent%
\begin{minipage}{#2}%
 \makebox[#2]{%
   #3}%
 \ifthenelse{\equal{#4}{}}{}%
   {\captionof{table}{#4}}%
 \ifthenelse{\equal{#1}{}}{}%
   {\label{#1}}%
\end{minipage}%
}%

\newlength{\@imageheight}%
\newlength{\@imagewidth}%
\newlength{\@alturaTxt}%
\newcounter{@NlinhasFig}%
\setlength{\columnsep}{16pt plus 4pt minus 2pt}%

\newcommand{\FIGcomTextoaolado}[5][]{%
\settoheight{\@imageheight}{\includegraphics{#4}}%
\settowidth{\@imagewidth}{\includegraphics{#4}}%
\setlength{\@alturaTxt}{#3*\ratio{\@imageheight}{\@imagewidth}}%
\ifthenelse{\equal{#2}{}}%
  {\setcounter{@NlinhasFig}{0}}%
  {\setcounter{@NlinhasFig}{#2}}%
\addtocounter{@NlinhasFig}{1*\ratio{\@alturaTxt}{12.5pt}}%
\begin{wrapfigure}[\value{@NlinhasFig}]{r}[0pt]{#3}%
 \includegraphics[width=#3]{#4}%
 \ifthenelse{\equal{#5}{}}{}%
   {\caption{#5}}%
 \ifthenelse{\equal{#1}{}}{}%
   {\label{#1}}%
\end{wrapfigure}%
}%
\@appendToHelpCmd[FIGcomTextoaolado]{[lbl]\{nl\}\{w\}\{img\}\{lgd\}}%
{Figura com texto ao lado}{ Esta figura N\AO\ \'e um float e, por isso, fica presa \`a palavra onde foi inclu\ii da. Os par\^ametros s\ao:\vspace*{-3.5mm}%
\begin{itemize}%
\itemsep -1mm%
\item \texttt{lbl}= label [opcional] que referencia a imagem. Deve ser do tipo \texttt{fig:xxxx}.%
\item \texttt{nl}= quantidade de linhas a ocupar pelo texto que fica ao lado (ajusta-o). %
NOTA: \textit{exige escolher bem} o n\'umero \texttt{nl} a acrescentar, para que o texto lateral fique bem distribu\ii do pela altura da figura+legenda.%
\item \texttt{w}= largura da fig. Ex: 100mm.%
\item \texttt{img}= filename da imagem.%
\item \texttt{lgd}= legenda da imagem.%
\end{itemize}\vspace*{-3mm}}{FigsTabs}%

\newcommand{\poefigEMminipage}[4][\linewidth]{%
  \setlength{\larguraimg}{#1}%
  \centering%
  \makebox[\linewidth]{\includegraphics[width=\larguraimg]{#2}}%
  \ifthenelse{\equal{#3}{}}{}%
    {\captionof{figure}{\footnotesize #3}}%
  \setlength{\rightskip}{1mm}%
  \setlength{\leftskip}{1mm}%
  \renewcommand{\baselinestretch}{0.7}%
  \ifthenelse{\equal{#4}{}}{}%
    {\label{#4}}%
  \vfil%
}%

\newcommand{\textoefigura}[5][]{%
  \ifthenelse{\equal{#2}{}}%
      {\duascaixasladoalado{0.5\textwidth}}%
      {\duascaixasladoalado{#2}}%
    {\poetextoEMminipage{#3}}%
    {\poefigEMminipage{#4}{#5}{#1}}%
}%
\@appendToHelpCmd[textoefigura]{[lbl]\{larg\}\{texto\}\{file.fig\}\{legenda\}}{Texto com Figura}{. Este co\-man\-do coloca o \texttt{texto} numa 'caixa' \`a esquerda e insere a  \texttt{figura} numa 'caixa' \`a direita. As 'caixas' s\ao o invis\ii veis e a mais alta imp\oe-se \`a outra. Conclus\ao: escolha bem a quantidade de texto que coloca, de modo que preencha tudo  verticalmente. Esta estrutura n\ao\ \'e um float e acompanha o par\'agrafo onde foi inclu\ii da. Os par\^ametros s\ao:\vspace*{-3.5mm}%
\begin{itemize}%
\itemsep -1mm%
\item \texttt{lbl}= label [opcional] que referencia a figura. Deve ser do tipo \texttt{fig:xxx}. %
\item \texttt{larg}= largura reservada ao texto. Ex: \texttt{110mm}. O tamanho vertical da figura \'e ajustado proporcionalmente \`a largura restante na linha.%
\item \texttt{texto}= O texto que se pretende colocar \`a esquerda da figura. Aten\cao\ ao n\'umero de linhas para n\ao\ ficar muito mais alto do que a figura.%
\item \texttt{file.fig}= nome da file da figura, com path se necess\'ario.%
\item \texttt{legenda}= legenda da figura.%
\end{itemize}\vspace*{-3mm}%
}{FigsTabs}%

\newcommand{\figuraetexto}[5][]{%
 \ifthenelse{\equal{#2}{}}%
  {\duascaixasladoalado{0.5\textwidth}}%
  {\duascaixasladoalado{#2}}%
  {\poefigEMminipage[\noexpand\larguracaixaesq]{#4}{#5}{#1}}%
  {\poetextoEMminipage{#3}}%
}%

\@appendToHelpCmd[figuraetexto]{[lbl]\{larg\}\{texto\}\{file.fig\}\{legenda\}}{Figura com Texto}{. Este co\-man\-do coloca a \texttt{figura} numa 'caixa' \`a esquerda e insere o \texttt{texto} numa 'caixa' \`a direita. As 'caixas' s\ao o invis\ii veis e a mais alta imp\oe\ o espa\co\ vertical. Conclus\ao: escolha bem a quantidade de texto que coloca, de modo que preencha tudo  verticalmente. Esta estrutura n\ao\ \'e um float e acompanha o par\'agrafo onde foi inclu\ii da. Os par\^ametros s\ao:\vspace*{-3.5mm}%
\begin{itemize}%
\itemsep -1mm%
\item \texttt{lbl}= label [opcional] que referencia a figura. Deve ser do tipo \texttt{fig:xxx}. %
\item \texttt{larg}= largura reservada \`a figura. Ex: \texttt{60mm}. O tamanho vertical \'e ajustado proporcionalmente.%
\item \texttt{texto}= O texto que se pretende colocar \`a direita da figura. Aten\cao\ ao n\'umero de linhas para n\ao\ ficar muito mais alto do que a figura.%
\item \texttt{file.fig}= nome da file da figura, com path se necess\'ario.%
\item \texttt{legenda}= legenda da figura.%
\end{itemize}\vspace*{-3mm}%
}{FigsTabs}%

\newcommand{\poefigCodeEMminipage}[4][\larguracaixadir]{%
  \setlength{\larguraimg}{#1}%
  \centering%
  \makebox[\linewidth]{#2}%
  \ifthenelse{\equal{#3}{}}{}%
    {\captionof{figure}{\footnotesize #3}}%
  \setlength{\rightskip}{1mm}%
  \setlength{\leftskip}{1mm}%
  \renewcommand{\baselinestretch}{0.7}%
  \ifthenelse{\equal{#4}{}}{}%
    {\label{#4}}%
  \vfil%
}%

\newcommand{\textoefigCode}[5][]{%
 \ifthenelse{\equal{#2}{}}%
  {\duascaixasladoalado{0.5\textwidth}}%
  {\duascaixasladoalado{#2}}%
  {\poetextoEMminipage{#3}}%
  {\poefigCodeEMminipage[\larguracaixadir]{#4}{#5}{#1}}%
}%

\@appendToHelpCmd[textoefigCode]{[lbl]\{larg\}\{texto\}\{figCode\}\{legenda\}}{Texto com Figuras juntas}{. Este co\-man\-do coloca o \texttt{texto} numa 'caixa' \`a esquerda e insere N figuras em \texttt{figCode} (lado a lado) numa 'caixa' \`a direita. %
As 'caixas' s\ao\ invis\ii veis e a mais alta imp\oe\ o espa\co\ vertical. Conclus\ao: escolha bem a quantidade de texto que coloca, de modo que preencha tudo verticalmente. Esta estrutura n\ao\ \'e um float e acompanha o par\'agrafo onde foi inclu\ii da. Os par\^ametros s\ao:\vspace*{-3.5mm}%
\begin{itemize}%
\itemsep -1mm%
\item \texttt{lbl}= label [opcional] que referencia as figuras. Deve ser do tipo \texttt{fig:xxx}. %
\item \texttt{larg}= largura reservada ao texto, ex: \texttt{110mm}. O restante espa\co\ na linha \'e para as N figuras.%
\item \texttt{texto}= O texto que se pretende colocar \`a esquerda da figura. Aten\cao\ ao n\'umero de linhas para n\ao\ ficar muito mais alto do que a figura.%
\item \texttt{figCode}= c\'odigo das N figuras que ficam lado a lado com uma \'unica legenda. Sequencialmente, cada uma das N figuras tem c\'o\-di\-go tipo %
\@macroName{includegraphics}{[etc]\{fg1.xxx\}}{.} \@macroName{hspace}{\{5mm\}}{.}. %
\item \texttt{legenda}= legenda da figura.%
\end{itemize}\vspace*{-3mm}%
}{FigsTabs}%

\newlength{\larguratabela}%
\newlength{\larguracaixaesq}%
\newlength{\larguracaixadir}%
\newlength{\larguraimg}%

\newcommand{\duascaixasladoalado}[3]{%
 \setlength{\larguracaixaesq}{#1}%
 \setlength{\larguracaixadir}{\textwidth}%
 \ifthenelse{\lengthtest{\larguracaixaesq > 0.95\textwidth}}%
   {\typeout{******ATENCAO: largura da caixa esq > 0.95\the\textwidth}%
   ******ATENCAO: largura da caixa > 0.95*\the\textwidth%
    \setlength{\larguracaixaesq}{0.95\textwidth}%
   }{}%
 \addtolength{\larguracaixadir}{-\larguracaixaesq-4mm}%
 \noindent%
 \begin{minipage}[c]{\larguracaixaesq}%
   #2%
 \end{minipage}%
 \hspace{4mm}%
 \begin{minipage}[c]{\larguracaixadir}%
   #3%
 \end{minipage}%
}%

\newcommand{\poetextoEMminipage}[2][1.0]{%
 \parskip 8pt%
 \renewcommand{\baselinestretch}{#1}%
 #2%
}%

\newcommand{\poetabEMminipage}[4][E]{%
  \centering%
  \makebox{#2}%
  \ifthenelse{\equal{#3}{}}{}%
    {\captionof{table}{#3}}%
  \setlength{\rightskip}{1mm}%
  \setlength{\leftskip}{1mm}%
  \renewcommand{\baselinestretch}{0.7}%
  \ifthenelse{\equal{#4}{}}{}%
    {\label{#4}}%
  \vfil%
}%

\newcommand{\tabelaetexto}[5][]{%
 \ifthenelse{\equal{#2}{}}%
   {\duascaixasladoalado{0.5\textwidth}}%
   {\duascaixasladoalado{#2}}%
 {\poetabEMminipage{#4}{#5}{#1}}%
 {\poetextoEMminipage{#3}}%
}%

\@appendToHelpCmd[tabelaetexto]{[lbl]\{larg\}\{texto\}\{tabela\}\{legenda\}}{Tabela com Texto}{. Este comando coloca a \texttt{tabela} numa 'caixa' \`a esquerda e insere o \texttt{texto} numa 'caixa' \`a direita. As 'caixas' s\ao\ invis\ii veis e a mais alta imp\oe\ o espa\co\ vertical. Conclus\ao: escolha bem a quantidade de texto que coloca, de modo que preencha tudo  verticalmente. Esta estrutura n\ao\ \'e um float e acompanha o par\'agrafo onde foi inclu\ii da. Os par\^ametros s\ao:\vspace*{-3.5mm}%
\begin{itemize}%
\itemsep -1mm%
\item \texttt{lbl}= label [opcional] que referencia a tabela. Deve ser do tipo \texttt{tab:xxx}. %
\item \texttt{larg}= largura que se quer reservar \`a tabela. Ex: \texttt{100mm}.%
\item \texttt{texto}= O texto que se pretende colocar \`a direita da tabela. Aten\cao\ ao tamanho em linhas para n\ao\ ficar muito mais alto do que a tabela.%
\item \texttt{tabela}= O c\'odigo \@macroName{begin}{\{tabular\}\{|c|\}}{.} etc.\ \@macroName{end}{\{tabular\}}{.} que cria a tabela.%
\item \texttt{legenda}= legenda da tabela.%
\end{itemize}\vspace*{-3mm}%
}{FigsTabs}%

\newcommand{\textoetabela}[5][]{%
  \ifthenelse{\equal{#2}{}}%
      {\duascaixasladoalado{0.5\textwidth}}%
      {\duascaixasladoalado{#2}}%
    {\poetextoEMminipage{#3}}%
    {\poetabEMminipage{#4}{#5}{#1}}%
}%

\@appendToHelpCmd[textoetabela]{[lbl]\{larg\}\{texto\}\{tabela\}\{legenda\}}{Texto com Tabela}{. Este comando coloca \texttt{texto} numa 'caixa' \`a esquerda e insere a \texttt{tabela} numa 'caixa' \`a direita. As 'caixas' s\ao\ invis\ii veis e a mais alta imp\oe\ o espa\co\ vertical. Conclus\ao: escolha bem a quantidade de texto que coloca, de modo que preencha tudo  verticalmente. Esta estrutura n\ao\ \'e um float e acompanha o par\'agrafo onde foi inclu\ii da. Os par\^ametros s\ao:\vspace*{-3.5mm}%
\begin{itemize}%
\itemsep -1mm%
\item \texttt{lbl}= label [opcional] que referencia a tabela. Deve ser do tipo \texttt{tab:xxx}. %
\item \texttt{larg}= largura que se quer reservar ao \texttt{texto}. Ex: \texttt{100mm}.%
\item \texttt{texto}= O texto que se pretende colocar \`a esquerda da tabela. Aten\cao\ ao tamanho em linhas para n\ao\ ficar muito mais alto do que a tabela.%
\item \texttt{tabela}= O c\'odigo \@macroName{begin}{\{tabular\}\{|c|\}}{.}  etc.\ \@macroName{end}{\{tabular\}}{.} que cria a tabela.%
\item \texttt{legenda}= legenda da tabela.%
\end{itemize}\vspace*{-3mm}%
}{FigsTabs}%

